package org.jboss.errai.marshalling.client.api;

import java.util.List;
import java.util.Map;
import java.util.Set;
import org.guvnor.asset.management.model.RepositoryStructureModel;
import org.guvnor.common.services.project.model.POM;
import org.guvnor.common.services.shared.metadata.model.Metadata;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;
import org.uberfire.backend.vfs.Path;

public class Marshaller_o_g_a_m_m_RepositoryStructureModel_1_Impl implements GeneratedMarshaller<RepositoryStructureModel> {
  private RepositoryStructureModel[] EMPTY_ARRAY = new RepositoryStructureModel[0];
  private Marshaller<POM> org_guvnor_common_services_project_model_POM = null;
  private Marshaller<Metadata> org_guvnor_common_services_shared_metadata_model_Metadata = null;
  private Marshaller java_lang_Object = Marshalling.getMarshaller(Object.class);
  private Marshaller<List> java_util_List = Marshalling.getMarshaller(List.class);
  private Marshaller<Map> java_util_Map = Marshalling.getMarshaller(Map.class);
  private Marshaller<Boolean> java_lang_Boolean = Marshalling.getMarshaller(Boolean.class);
  public RepositoryStructureModel[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  native static List RepositoryStructureModel_List_modules(RepositoryStructureModel instance) /*-{
    return instance.@org.guvnor.asset.management.model.RepositoryStructureModel::modules;
  }-*/;

  native static void RepositoryStructureModel_List_modules(RepositoryStructureModel instance, List<String> value) /*-{
    instance.@org.guvnor.asset.management.model.RepositoryStructureModel::modules = value;
  }-*/;

  public RepositoryStructureModel demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(RepositoryStructureModel.class, objId);
    }
    RepositoryStructureModel entity = new RepositoryStructureModel();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "pom": entity.setPOM(org_guvnor_common_services_project_model_POM.demarshall(objVal, a1));
        break;
        case "POMMetaData": entity.setPOMMetaData(org_guvnor_common_services_shared_metadata_model_Metadata.demarshall(objVal, a1));
        break;
        case "pathToPOM": entity.setPathToPOM((Path) ((ObjectMarshaller) java_lang_Object).demarshall(Path.class, objVal, a1));
        break;
        case "modules": a1.setAssumedElementType("java.lang.String");
        RepositoryStructureModel_List_modules(entity, java_util_List.demarshall(objVal, a1));
        break;
        case "modulesProject": a1.setAssumedMapKeyType("java.lang.String");
        a1.setAssumedMapValueType("org.guvnor.common.services.project.model.Project");
        entity.setModulesProject(java_util_Map.demarshall(objVal, a1));
        a1.resetAssumedTypes();
        break;
        case "orphanProjects": a1.setAssumedElementType("org.guvnor.common.services.project.model.Project");
        entity.setOrphanProjects(java_util_List.demarshall(objVal, a1));
        break;
        case "orphanProjectsPOM": a1.setAssumedMapKeyType("java.lang.String");
        a1.setAssumedMapValueType("org.guvnor.common.services.project.model.POM");
        entity.setOrphanProjectsPOM(java_util_Map.demarshall(objVal, a1));
        a1.resetAssumedTypes();
        break;
        case "managed": entity.setManaged(java_lang_Boolean.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  public String marshall(RepositoryStructureModel a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.guvnor.asset.management.model.RepositoryStructureModel") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((((((((((((((("" + ",\"") + "pom") + "\":") + org_guvnor_common_services_project_model_POM.marshall(a0.getPOM(), a1)) + ",\"") + "POMMetaData") + "\":") + org_guvnor_common_services_shared_metadata_model_Metadata.marshall(a0.getPOMMetaData(), a1)) + ",\"") + "pathToPOM") + "\":") + java_lang_Object.marshall(a0.getPathToPOM(), a1)) + ",\"") + "modules") + "\":") + java_util_List.marshall(a0.getModules(), a1)) + ",\"") + "modulesProject") + "\":") + java_util_Map.marshall(a0.getModulesProject(), a1)) + ",\"") + "orphanProjects") + "\":") + java_util_List.marshall(a0.getOrphanProjects(), a1)) + ",\"") + "orphanProjectsPOM") + "\":") + java_util_Map.marshall(a0.getOrphanProjectsPOM(), a1)) + ",\"") + "managed") + "\":") + java_lang_Boolean.marshall(a0.getManaged(), a1)) + "}");
  }

  private void lazyInit() {
    if (org_guvnor_common_services_project_model_POM == null) {
      org_guvnor_common_services_project_model_POM = Marshalling.getMarshaller(POM.class);
    }
    if (org_guvnor_common_services_shared_metadata_model_Metadata == null) {
      org_guvnor_common_services_shared_metadata_model_Metadata = Marshalling.getMarshaller(Metadata.class);
    }
  }
}