package org.jboss.errai.marshalling.client.api;

import java.util.Collection;
import java.util.Set;
import org.guvnor.common.services.project.model.POM;
import org.guvnor.common.services.project.model.Project;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;
import org.uberfire.backend.vfs.Path;

public class Marshaller_o_g_c_s_p_m_Project_1_Impl implements GeneratedMarshaller<Project> {
  private Project[] EMPTY_ARRAY = new Project[0];
  private Marshaller java_lang_Object = Marshalling.getMarshaller(Object.class);
  private Marshaller<String> java_lang_String = Marshalling.getMarshaller(String.class);
  private Marshaller<Boolean> java_lang_Boolean = Marshalling.getMarshaller(Boolean.class);
  private Marshaller<POM> org_guvnor_common_services_project_model_POM = null;
  private Marshaller<Integer> java_lang_Integer = Marshalling.getMarshaller(Integer.class);
  public Project[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  native static Path Project_Path_rootPath(Project instance) /*-{
    return instance.@org.guvnor.common.services.project.model.Project::rootPath;
  }-*/;

  native static void Project_Path_rootPath(Project instance, Path value) /*-{
    instance.@org.guvnor.common.services.project.model.Project::rootPath = value;
  }-*/;

  native static Path Project_Path_pomXMLPath(Project instance) /*-{
    return instance.@org.guvnor.common.services.project.model.Project::pomXMLPath;
  }-*/;

  native static void Project_Path_pomXMLPath(Project instance, Path value) /*-{
    instance.@org.guvnor.common.services.project.model.Project::pomXMLPath = value;
  }-*/;

  native static String Project_String_projectName(Project instance) /*-{
    return instance.@org.guvnor.common.services.project.model.Project::projectName;
  }-*/;

  native static void Project_String_projectName(Project instance, String value) /*-{
    instance.@org.guvnor.common.services.project.model.Project::projectName = value;
  }-*/;

  native static Collection Project_Collection_modules(Project instance) /*-{
    return instance.@org.guvnor.common.services.project.model.Project::modules;
  }-*/;

  native static void Project_Collection_modules(Project instance, Collection<String> value) /*-{
    instance.@org.guvnor.common.services.project.model.Project::modules = value;
  }-*/;

  native static Collection Project_Collection_groups(Project instance) /*-{
    return instance.@org.guvnor.common.services.project.model.Project::groups;
  }-*/;

  native static void Project_Collection_groups(Project instance, Collection<String> value) /*-{
    instance.@org.guvnor.common.services.project.model.Project::groups = value;
  }-*/;

  native static boolean Project_boolean_requiresRefresh(Project instance) /*-{
    return instance.@org.guvnor.common.services.project.model.Project::requiresRefresh;
  }-*/;

  native static void Project_boolean_requiresRefresh(Project instance, boolean value) /*-{
    instance.@org.guvnor.common.services.project.model.Project::requiresRefresh = value;
  }-*/;

  public Project demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(Project.class, objId);
    }
    Project entity = new Project();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "rootPath": Project_Path_rootPath(entity, (Path) ((ObjectMarshaller) java_lang_Object).demarshall(Path.class, objVal, a1));
        break;
        case "pomXMLPath": Project_Path_pomXMLPath(entity, (Path) ((ObjectMarshaller) java_lang_Object).demarshall(Path.class, objVal, a1));
        break;
        case "projectName": Project_String_projectName(entity, java_lang_String.demarshall(objVal, a1));
        break;
        case "modules": Project_Collection_modules(entity, (Collection) ((ObjectMarshaller) java_lang_Object).demarshall(Collection.class, objVal, a1));
        break;
        case "groups": Project_Collection_groups(entity, (Collection) ((ObjectMarshaller) java_lang_Object).demarshall(Collection.class, objVal, a1));
        break;
        case "requiresRefresh": Project_boolean_requiresRefresh(entity, java_lang_Boolean.demarshall(objVal, a1));
        break;
        case "pom": entity.setPom(org_guvnor_common_services_project_model_POM.demarshall(objVal, a1));
        break;
        case "numberOfAssets": entity.setNumberOfAssets(java_lang_Integer.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  public String marshall(Project a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.guvnor.common.services.project.model.Project") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((((((((((((((("" + ",\"") + "rootPath") + "\":") + java_lang_Object.marshall(a0.getRootPath(), a1)) + ",\"") + "pomXMLPath") + "\":") + java_lang_Object.marshall(a0.getPomXMLPath(), a1)) + ",\"") + "projectName") + "\":") + java_lang_String.marshall(a0.getProjectName(), a1)) + ",\"") + "modules") + "\":") + java_lang_Object.marshall(a0.getModules(), a1)) + ",\"") + "groups") + "\":") + java_lang_Object.marshall(a0.getGroups(), a1)) + ",\"") + "requiresRefresh") + "\":") + java_lang_Boolean.marshall(Project_boolean_requiresRefresh(a0), a1)) + ",\"") + "pom") + "\":") + org_guvnor_common_services_project_model_POM.marshall(a0.getPom(), a1)) + ",\"") + "numberOfAssets") + "\":") + java_lang_Integer.marshall(a0.getNumberOfAssets(), a1)) + "}");
  }

  private void lazyInit() {
    if (org_guvnor_common_services_project_model_POM == null) {
      org_guvnor_common_services_project_model_POM = Marshalling.getMarshaller(POM.class);
    }
  }
}