package org.jboss.errai.marshalling.client.api;

import com.google.gwt.core.shared.GWT;
import java.util.AbstractMap;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;
import javax.enterprise.context.Dependent;
import org.jboss.errai.marshalling.client.marshallers.BigDecimalMarshaller;
import org.jboss.errai.marshalling.client.marshallers.BigIntegerMarshaller;
import org.jboss.errai.marshalling.client.marshallers.BooleanMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ByteMarshaller;
import org.jboss.errai.marshalling.client.marshallers.CharacterMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ClientClassMarshaller;
import org.jboss.errai.marshalling.client.marshallers.DateMarshaller;
import org.jboss.errai.marshalling.client.marshallers.DoubleMarshaller;
import org.jboss.errai.marshalling.client.marshallers.FloatMarshaller;
import org.jboss.errai.marshalling.client.marshallers.IntegerMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LinkedHashSetMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LinkedListMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LinkedMapMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ListMarshaller;
import org.jboss.errai.marshalling.client.marshallers.LongMarshaller;
import org.jboss.errai.marshalling.client.marshallers.MapMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;
import org.jboss.errai.marshalling.client.marshallers.OptionalMarshaller;
import org.jboss.errai.marshalling.client.marshallers.PriorityQueueMarshaller;
import org.jboss.errai.marshalling.client.marshallers.QualifyingMarshallerWrapper;
import org.jboss.errai.marshalling.client.marshallers.QueueMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SQLDateMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SetMarshaller;
import org.jboss.errai.marshalling.client.marshallers.ShortMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SortedMapMarshaller;
import org.jboss.errai.marshalling.client.marshallers.SortedSetMarshaller;
import org.jboss.errai.marshalling.client.marshallers.StringBufferMarshaller;
import org.jboss.errai.marshalling.client.marshallers.StringBuilderMarshaller;
import org.jboss.errai.marshalling.client.marshallers.StringMarshaller;
import org.jboss.errai.marshalling.client.marshallers.TimeMarshaller;
import org.jboss.errai.marshalling.client.marshallers.TimestampMarshaller;
import org.kie.workbench.common.stunner.bpmn.client.forms.fields.model.AssignmentDataMarshaller;
import org.uberfire.rpc.impl.SessionInfoMarshalller;
@Dependent public class MarshallerFactoryImpl implements MarshallerFactory {
  private Map<String, Marshaller> marshallers = new HashMap<String, Marshaller>();
  abstract class Marshaller_for_java_lang_Throwable implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_ArithmeticException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_io_IOException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_IllegalArgumentException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_util_EmptyStackException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_ArrayStoreException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_ClassCastException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_util_ConcurrentModificationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_IndexOutOfBoundsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_NegativeArraySizeException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_NullPointerException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_StringIndexOutOfBoundsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_UnsupportedOperationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_AssertionError implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_RuntimeException implements GeneratedMarshaller { }
  abstract class Marshaller_for_java_lang_StackTraceElement implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_SecurityException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_UnauthenticatedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_UnauthorizedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_AuthenticationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_workitem_IconDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_ModuleRepositories implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontFamily implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_BusinessRuleTask implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Module implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_MediaAdded implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_CloneConnectorCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_diagram_MetadataImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_bean_PreferenceRootElement implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_BusinessRuleTaskExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_ReusableSubprocess implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_DSLActionSentence implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_connectors_SequenceFlowExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontColor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_entries_FieldRequiredEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_Version implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_NewPluginRegistered implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_Notification_erraiD_State implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_impl_OrganizationalUnitImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_background_BackgroundSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_exception_DefinitionNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_escalation_CancellingEscalationEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssigneeEditorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_NotDirectoryException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateMessageEventCatching implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_mvp_impl_ForcedPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_CapabilityStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_ContextOperationNotAllowedViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_DefaultTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_CancellingSignalEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_RepoRemovedFromOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromEntryPointFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_radioGroup_definition_DecimalRadioGroupFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_timer_TimerSettings implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_backend_impl_ExperimentalFeaturesSessionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorFieldInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceRenamedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_RuleSetImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_ReusableSubprocessTaskExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLSentence implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_CloneNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialActivitiesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_FormDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_EdgeOccurrences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_subProcess_execution_EmbeddedSubprocessExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_datePicker_definition_DatePickerFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_PartDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionRetractFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DockNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_FailedAuthenticationException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeListFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_editor_EditableExperimentalFeature implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_Radius implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_CharacterListBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreference implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceCompletionCondition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFieldVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_EntityNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_ContextDisplayMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_MultipleInstanceSubprocess implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_RuleViolationImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_social_ModuleEventType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_impl_MapModelRenderingContext implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginUnregistered implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateEscalationEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_ext_RuleExtension implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_DiagramSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_relations_multipleSubform_definition_MultipleSubFormFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_service_DeploymentMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_radioGroup_definition_IntegerRadioGroupFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_GridPreferencesStore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceChangeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_impl_NodeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_dynamic_model_document_DocumentStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_WorkingHours implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableBooleanParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssignmentsEditorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_SearchResponseImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_lookup_VFSLookupRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_PluginAddedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_authz_AuthorizationResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_impl_DefinitionSetImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_RemoveParentCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_NewOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationPolicy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_StandardDeviation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_EnvironmentParameters implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_mvp_impl_PathPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_RectangleDimensionsSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_definition_DefinitionSetImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_RuntimePlugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_LayoutEditorModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_exception_AlreadyLoggedInException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Language implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_model_IncrementalBuildResults implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dataio_AssignmentsInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_DataType_erraiD_DataTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_plugin_RuntimePlugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_definition_ExperimentalFeatureDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_DistributionType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartCompensationEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_navigator_DataContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_impl_PortableJavaModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UpdateDomainObjectPropertyValueCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryRemovedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_slider_definition_IntegerSliderDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_EmptyRuleSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOModuleCacheEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_integerBox_definition_IntegerBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_exception_PluginAlreadyExists implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_security_ProjectResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_validation_ValidationResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeleteNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Mean implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_escalation_EscalationEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_LockInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartNoneEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_CircleDimensionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_relations_subForm_definition_SubFormFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseTaskMorphPropertyDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_events_SocialUserUnFollowedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_cm_client_command_graph_CaseManagementDeleteElementsCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_Lane implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraintEBLeftSide implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SetConnectionTargetNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_lookup_definition_DefinitionRepresentation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_cm_client_command_graph_CaseManagementAddNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_textBox_definition_TextBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfigurations implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateSignalEventThrowing implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCollectCompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_UserManagerSettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SetConnectionSourceNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Plugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SafeDeleteNodeCommand_erraiD_Options implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssigneeEditorFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_RenderMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionUpdateField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_EnumListBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_WorkItemHandlerModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_NewPackageEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_cm_definition_CaseManagementDiagram implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_DefaultPreferenceScopeResolver implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_entries_FieldLabelEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddDockedNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Plugin implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateConditionalEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceUpdated implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Min implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_radioGroup_definition_StringRadioGroupFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleBaselinePayload implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionCallMethod implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_BooleanMultipleSelectorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_AdHocSubprocessTaskExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateTimerEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_metadata_model_DiscussionRecord implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_FileSystemFactory_erraiD_FileSystemImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_gateway_DefaultRoute implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_BPMNDiagramImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_ScriptTypeList implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartTimerEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenuItem implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_validators_TextValidator implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_CancelActivity implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleAttribute implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionWorkItemFieldValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleIncrementalPayload implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_AdHocCompletionCondition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_cm_RolesEditorFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_api_RoleImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableFloatParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOPackageCacheEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseNonContainerSubprocessMorphDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopedValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceOpenedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_RepoAddedToOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_preferences_StunnerPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_validation_model_ValidationMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UpdateElementPropertyValueCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_command_impl_CommandResultImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddChildNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceSubprocessTaskExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_compensation_CompensationEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseTaskMorphPropertyDefinition_erraiD_TaskTypeMorphProperty implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartMessageEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_bean_PreferenceHierarchyElement implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_GroupManagerSettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_Association implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_variables_ProcessData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_common_client_PageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_entries_FieldTypeEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_command_impl_DeferredCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_service_ProjectType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MITrigger implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateSignalEventCatching implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_general_Name implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginSaved implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_OrganizationalUnitEventBase implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_registry_impl_ExperimentalFeaturesRegistryImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Format implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_lookup_diagram_DiagramLookupRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_DirectoryStreamImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_UberfireJSAPIReadyEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_paging_PageRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_ViewConnectorImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UpdateControlPointPositionCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_IntegerType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_ClearGraphCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_TimerSettingsType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_UserAttributeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_StringMultipleInputFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Quantity implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_ModuleRepositories_erraiD_ModuleRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_model_BuildMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddControlPointCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceDataOutput implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeListFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_PanelDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLVariableValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_general_Documentation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_service_PackageAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseSubprocessMorphDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_timer_TimerSettingsValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_cm_definition_EmbeddedSubprocess implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_CalledElement implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseThrowingIntermediateEventMorphDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_api_identity_UserImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_error_InterruptingErrorEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeleteElementsCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceCollectionOutput implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_Notification implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_POM implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_impl_validation_DynamicModelConstraints implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_GitMetadataImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_MagnetConnection implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_events_AuthorizationPolicySavedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_MavenRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_EdgeCardinalityMinRuleViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_MavenRepositorySource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Skippable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_StringSelectorOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethod implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_relationship_Dock implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_CardinalityMinRuleViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_DefaultRuleViolations implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_CanDock implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_ScriptTypeListValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Independent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_morph_MorphDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_PluginReloadedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_TaskPropertyType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UpdateElementPositionCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_PagedSocialQuery implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateMessageEventThrowing implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_lookup_rule_RuleLookupRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_apps_api_DirectoryBreadcrumb implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceRenamed implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_subProcess_execution_EventSubprocessExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_message_CancellingMessageEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_EmptyConnectionViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_message_MessageEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_imports_Imports implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_Occurrences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetSettings implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Subject implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenu implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_PluginSimpleContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_UserTask implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_escalation_EscalationRef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_RealmManagementNotAuthorizedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_clone_ClonePolicy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_Package implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_IntegerSelectorOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_apps_api_Directory implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_Branch implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_CreatedBy implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_background_BorderSize implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_relations_Container implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_auditlog_AuditLog implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_CLASS_erraiU_TYPE implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_lookup_diagram_DiagramRepresentation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_ViewImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FreeFormLine implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_ProjectImports implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_ProcessInstanceDescription implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_timer_CancellingTimerEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleModel implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_SequenceFlow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_DataType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontBorderColor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_AssignmentsType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_DeleteModuleEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_Id implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_version_impl_PortableVersionRecord implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_VariablesEditorFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldFunction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_jboss_errai_security_shared_api_GroupImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_SignalRef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_IsAsync implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_cm_client_command_graph_CaseManagementRemoveChildCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_impl_TypeInfoImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_textArea_definition_TextAreaFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Build implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_DecimalMultipleSelectorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialUser implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_GridColumnPreference implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_impl_GraphImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ConditionalComboBoxFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_PluginUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_GAV implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableObjectParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceDeletedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_ClosedWatchServiceException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableIntegerParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_Height implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_ModuleUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Unit implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_UserAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_impl_PropertySetImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_CompassPosition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFormLine implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_MavenRepositoryMetadata implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableStringParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_NamedPosition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_navigator_NavigatorContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_UserNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_cm_definition_AdHocSubprocess implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_NewProjectEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Dependency implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_cm_CaseFileVariables implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_Point2D implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_checkBox_definition_CheckBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndEscalationEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_security_GlobalExperimentalFeatureResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_lookup_definition_DefinitionLookupRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dataio_DataIOSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseTaskMorphDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_validation_impl_ModelBeanViolationImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeleteConnectorCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_RoleManagerSettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_FileExportsPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_forms_context_PathAwareFormContext implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialFileSelectedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_background_BgColor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_RemoveChildCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_command_impl_DeferredCompositeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutComponent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_PluginContent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_impl_EdgeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_workitem_WorkItemDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_InterruptingSignalEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_radioGroup_definition_CharacterRadioGroupFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ConnectiveConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionText implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_ControlPoint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_InclusiveGateway implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileSystemAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_DecimalMultipleInputFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_StringListBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollectionIndex implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_oracle_DSLConditionSentence implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginAdded implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_validation_impl_ElementViolationImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_IntegerMultipleInputFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndCompensationEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_cm_definition_ReusableSubprocess implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionGlobalVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileSystemNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_common_ConditionExpression implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromAccumulateCompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_impl_StaticModelFormRenderingContext implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_ScriptTypeValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_CharacterMultipleInputFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_TimeUnit implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_security_RepositoryResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_NoneTask implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_Point2DConnection implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_dynamic_model_config_SelectorData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseCatchingIntermediateEventMorphDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_AdHocAutostart implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_error_ErrorRef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_DropDownData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_registry_impl_ExperimentalFeatureImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Package implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_imports_Import implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_InvalidEntityIdentifierException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_StringType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ssh_service_shared_editor_PortableSSHPublicKey implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontBorderSize implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_preferences_StunnerDiagramEditorPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_CharacterMultipleSelectorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_metadata_model_Overview implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_AssigneeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_DoubleType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_StringMultipleSelectorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_forms_model_ColorPickerFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_BoundsExceededViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_DirectoryNotEmptyException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_CEPWindow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_security_OrgUnitResourceType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollection implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_preferences_GeneralPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_experimental_service_events_PortableExperimentalFeatureModifiedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EventSubprocess implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_CodeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_message_MessageRef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_ParallelGateway implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ComboBoxFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_general_TaskGeneralSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableWorkDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_EmptyTaskExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_CanConnect_erraiD_PermittedConnection implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_PullRequestImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCompositeFactPattern implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Script implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_CharacterSelectorOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_PropertyFormOptions implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_SettingsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionSetField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_ContextDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopeImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartErrorEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceAdded implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_LockResult implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_cm_CaseManagementSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_AdHocSubprocess implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate_erraiD_Style implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_impl_ModelPropertyImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_UserWorkbenchPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_context_WorkspaceProjectContextChangeEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_InvalidPathException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_RuleModelVisitor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_cm_CaseRoles implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SafeDeleteNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutColumn implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_message_InterruptingMessageEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_SimulationAttributeSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_BooleanMultipleInputFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_ContainmentRuleViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionGlobalCollectionAdd implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_VariablesType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_image_definition_PictureSize implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_NoSuchFileException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_BooleanType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_decimalBox_definition_DecimalBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_compensation_ActivityRef implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateCompensationEventThrowing implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartSignalEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_WaitForCompletion implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_TypeKind implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceCollectionInput implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_auditlog_DefaultAuditLogFilter implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_RuleFlowGroup implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_connectors_Priority implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Currency implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_SplashScreenFilterImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_metadata_model_Metadata implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_spaces_Space implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_gateway_GatewayExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryExternalUpdateEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_ScopedSignalEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_CopyExpressionVisitor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_DateMultipleSelectorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_ScriptType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Orientation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_InterpolationVariable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_UpdatedOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_organizationalunit_RemoveOrganizationalUnitEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_TaskTypes implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleMetadata implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_IntegerListBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_imports_Import implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_NotLinkException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_OperatorsOracle implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_exceptions_GenericPortableException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartEscalationEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeregisterNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_builder_model_BuildResults implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateEscalationEventThrowing implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_domainobject_DefaultDomainObject implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_DefaultPublicURI implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_diagram_DiagramImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_paging_PageResponse implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartConditionalEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_ProviderNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Media implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_preferences_GAVPreferencesPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Description implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_impl_validation_FieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_test_TestResultMessage implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialPaged_erraiD_Direction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssignmentsEditorFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_validation_BPMNViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_DateMultipleInputFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_dynamic_model_document_DocumentData implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_PatternSyntaxException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeleteControlPointCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_UnitCost implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceAddedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertLogicalFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_background_BorderColor implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_ORIGIN implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_impl_DefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_OnEntryAction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_relationship_Child implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_cm_RolesEditorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EmbeddedSubprocess implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndMessageEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_definition_DefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_assignee_Actors implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_ConnectionRuleViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_textBox_definition_CharacterBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_AdHocOrdering implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ComboBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_SignalScope implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ConditionalComboBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_timer_InterruptingTimerEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_TimerSettingsFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceCopiedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_IOException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndErrorEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_relationship_Parent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseEndEventMorphDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndNoneEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_escalation_InterruptingEscalationEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_validators_LongValidator implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_forms_service_FormGeneratedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_AdHoc implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseStartEventMorphDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UnDockNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_IntegerMultipleSelectorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseGatewayMorphDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_assignee_Groupid implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_PluginRenamed implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_readonly_ReadOnlyPathPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateErrorEventCatching implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_impl_git_GitRepository implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DefaultPermissionCollection implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfiguration implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_TaskType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_variables_ProcessVariables implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLComplexVariableValue implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_BoundsImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateCompensationEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_mvp_impl_DefaultPlaceRequest implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_error_ErrorEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_general_BPMNGeneralSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_Dependencies implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_OnExitAction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_Width implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_EnumSelectorOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_conditional_InterruptingConditionalEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_BoundImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_cm_client_command_graph_CaseManagementSafeDeleteNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_DecimalSelectorOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_conditional_CancellingConditionalEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceCopied implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DotNamedPermission implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_TypeSource implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_NoImplementationAvailableException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_SecurityManagementException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_ExclusiveGateway implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionUnboundFact implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_social_OrganizationalUnitEventType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_lookup_LookupResponseImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_EnumType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_workitem_ServiceTask implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_ScriptTaskExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_forms_service_FormGenerationFailureEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_events_NewModuleEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_model_WorkspaceProject implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_NewRepositoryEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_Executable implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_services_datamodel_model_LazyModelField implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_PluginType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_NewBranchEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_image_definition_PictureFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_FileSystemException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SetChildNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_diagram_DiagramParsingException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_MorphNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_Capability implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_test_Failure implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialPaged implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Max implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_ResourceBatchChangesEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_UserTaskExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_validators_ColorValidator implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_AccessDeniedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_ColorType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_model_SocialActivitiesEvent_erraiD_LINK_erraiU_TYPE implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_CanConnect implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_TaskName implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_BaseSingleFieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_ModelMetaDataImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_model_impl_PerspectiveDefinitionImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_service_GAVAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_GroupNotFoundException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_relations_TableColumnMeta implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontSize implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddConnectorCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_definition_impl_PropertyImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SetParentNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_store_GraphNodeStoreImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_error_CancellingErrorEventExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_event_MediaDeleted implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionExecuteWorkItem implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_workitem_ServiceTaskExecutionSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_exception_InvalidPreferenceScopeException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_ScriptTask implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorCategory implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_java_nio_file_AtomicMoveNotSupportedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_CanContain implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_PathFactory_erraiD_PathImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_DockingRuleViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_ext_uberfire_social_activities_events_SocialUserFollowedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_DefaultSelectorOption implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_MethodInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndTerminateEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Activity implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_bean_mock_PortablePreferenceMockPortableGeneratedImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutRow implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_SimulationSet implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndSignalEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_MultiGridPreferencesStore implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_TimerSettingsFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_shared_message_Level implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_RepositoryUpdatedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_slider_definition_DoubleSliderDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_OperationFailedException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_Annotation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_impl_SearchRequestImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_vfs_impl_ObservablePathImpl implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_IsInterrupting implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableListParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_plugin_model_Framework implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_model_meta_entries_FieldPlaceHolderEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_command_impl_CompositeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_security_management_api_exception_UnsupportedServiceCapabilityException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_EdgeCardinalityMaxRuleViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_RegisterNodeCommand implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_PullRequestAlreadyExistsException implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_soup_project_datamodel_oracle_FieldAccessorsAndMutators implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableEnumParameterDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_CardinalityMaxRuleViolation implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopeResolutionStrategyInfo implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_repositories_PullRequestStatus implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_entries_FieldReadOnlyEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_VariablesEditorFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFieldConstraint implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_structure_config_SystemRepositoryChangedEvent implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationEntry implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_GridGlobalPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_forms_model_ColorPickerFieldType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceDataInput implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_DecimalListBoxFieldDefinition implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_preferences_StunnerPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_editor_commons_file_exports_FileExportsPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_preferences_StunnerDiagramEditorPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_preferences_GeneralPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_guvnor_common_services_project_preferences_GAVPreferences implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_preferences_shared_bean_mock_PortablePreferenceMock implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssigneeType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_validation_Violation_erraiD_Type implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_rule_context_EdgeCardinalityContext_erraiD_Direction implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeMode implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreferencesType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_backend_plugin_PluginProcessor_erraiD_PluginProcessorType implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_kie_workbench_common_stunner_core_command_CommandResult_erraiD_Type implements GeneratedMarshaller { }
  abstract class Marshaller_for_org_uberfire_workbench_events_NotificationEvent_erraiD_NotificationType implements GeneratedMarshaller { }
  public MarshallerFactoryImpl() {
    final ObjectMarshaller java_lang_Object = new ObjectMarshaller();
    marshallers.put("java.lang.Object", java_lang_Object);
    final BigDecimalMarshaller java_math_BigDecimal = new BigDecimalMarshaller();
    marshallers.put("java.math.BigDecimal", java_math_BigDecimal);
    final QualifyingMarshallerWrapper<Map> java_util_Map = new QualifyingMarshallerWrapper(new MapMarshaller(), MapMarshaller.class);
    marshallers.put("java.util.Map", java_util_Map);
    marshallers.put("java.util.AbstractMap", java_util_Map);
    marshallers.put("java.util.HashMap", java_util_Map);
    marshallers.put("java.util.Collections$SynchronizedMap", java_util_Map);
    marshallers.put("java.util.Collections$EmptyMap", java_util_Map);
    marshallers.put("java.util.Collections$UnmodifiableMap", java_util_Map);
    marshallers.put("java.util.Collections$SingletonMap", java_util_Map);
    final QualifyingMarshallerWrapper<AbstractMap> java_util_AbstractMap = new QualifyingMarshallerWrapper(new MapMarshaller(), MapMarshaller.class);
    marshallers.put("java.util.AbstractMap", java_util_AbstractMap);
    final QualifyingMarshallerWrapper<HashMap> java_util_HashMap = new QualifyingMarshallerWrapper(new MapMarshaller(), MapMarshaller.class);
    marshallers.put("java.util.HashMap", java_util_HashMap);
    final BooleanMarshaller java_lang_Boolean = new BooleanMarshaller();
    marshallers.put("java.lang.Boolean", java_lang_Boolean);
    final DateMarshaller java_util_Date = new DateMarshaller();
    marshallers.put("java.util.Date", java_util_Date);
    final FloatMarshaller java_lang_Float = new FloatMarshaller();
    marshallers.put("java.lang.Float", java_lang_Float);
    final ByteMarshaller java_lang_Byte = new ByteMarshaller();
    marshallers.put("java.lang.Byte", java_lang_Byte);
    final QualifyingMarshallerWrapper<SortedMap> java_util_SortedMap = new QualifyingMarshallerWrapper(new SortedMapMarshaller(), SortedMapMarshaller.class);
    marshallers.put("java.util.SortedMap", java_util_SortedMap);
    marshallers.put("java.util.TreeMap", java_util_SortedMap);
    marshallers.put("java.util.Collections$SynchronizedSortedMap", java_util_SortedMap);
    marshallers.put("java.util.Collections$UnmodifiableSortedMap", java_util_SortedMap);
    final QualifyingMarshallerWrapper<TreeMap> java_util_TreeMap = new QualifyingMarshallerWrapper(new SortedMapMarshaller(), SortedMapMarshaller.class);
    marshallers.put("java.util.TreeMap", java_util_TreeMap);
    final QualifyingMarshallerWrapper<LinkedHashMap> java_util_LinkedHashMap = new QualifyingMarshallerWrapper(new LinkedMapMarshaller(), LinkedMapMarshaller.class);
    marshallers.put("java.util.LinkedHashMap", java_util_LinkedHashMap);
    final BigIntegerMarshaller java_math_BigInteger = new BigIntegerMarshaller();
    marshallers.put("java.math.BigInteger", java_math_BigInteger);
    final DoubleMarshaller java_lang_Double = new DoubleMarshaller();
    marshallers.put("java.lang.Double", java_lang_Double);
    final SQLDateMarshaller java_sql_Date = new SQLDateMarshaller();
    marshallers.put("java.sql.Date", java_sql_Date);
    final StringMarshaller java_lang_String = new StringMarshaller();
    marshallers.put("java.lang.String", java_lang_String);
    final SessionInfoMarshalller org_uberfire_rpc_SessionInfo = new SessionInfoMarshalller();
    marshallers.put("org.uberfire.rpc.SessionInfo", org_uberfire_rpc_SessionInfo);
    final LinkedHashSetMarshaller java_util_LinkedHashSet = new LinkedHashSetMarshaller();
    marshallers.put("java.util.LinkedHashSet", java_util_LinkedHashSet);
    final StringBuilderMarshaller java_lang_StringBuilder = new StringBuilderMarshaller();
    marshallers.put("java.lang.StringBuilder", java_lang_StringBuilder);
    final IntegerMarshaller java_lang_Integer = new IntegerMarshaller();
    marshallers.put("java.lang.Integer", java_lang_Integer);
    final TimestampMarshaller java_sql_Timestamp = new TimestampMarshaller();
    marshallers.put("java.sql.Timestamp", java_sql_Timestamp);
    final SetMarshaller java_util_Set = new SetMarshaller();
    marshallers.put("java.util.Set", java_util_Set);
    marshallers.put("java.util.AbstractSet", java_util_Set);
    marshallers.put("java.util.HashSet", java_util_Set);
    marshallers.put("java.util.Collections$SynchronizedSet", java_util_Set);
    marshallers.put("java.util.Collections$UnmodifiableSet", java_util_Set);
    marshallers.put("java.util.Collections$SingletonSet", java_util_Set);
    marshallers.put("java.util.Collections$EmptySet", java_util_Set);
    final SetMarshaller java_util_AbstractSet = new SetMarshaller();
    marshallers.put("java.util.AbstractSet", java_util_AbstractSet);
    final SetMarshaller java_util_HashSet = new SetMarshaller();
    marshallers.put("java.util.HashSet", java_util_HashSet);
    final LinkedListMarshaller java_util_LinkedList = new LinkedListMarshaller();
    marshallers.put("java.util.LinkedList", java_util_LinkedList);
    final LongMarshaller java_lang_Long = new LongMarshaller();
    marshallers.put("java.lang.Long", java_lang_Long);
    final ClientClassMarshaller java_lang_Class = new ClientClassMarshaller();
    marshallers.put("java.lang.Class", java_lang_Class);
    final ListMarshaller java_util_List = new ListMarshaller();
    marshallers.put("java.util.List", java_util_List);
    marshallers.put("java.util.AbstractList", java_util_List);
    marshallers.put("java.util.ArrayList", java_util_List);
    marshallers.put("java.util.Vector", java_util_List);
    marshallers.put("java.util.Stack", java_util_List);
    marshallers.put("java.util.Collections$SynchronizedRandomAccessList", java_util_List);
    marshallers.put("java.util.Collections$SynchronizedList", java_util_List);
    marshallers.put("java.util.Collections$SingletonList", java_util_List);
    marshallers.put("java.util.Collections$EmptyList", java_util_List);
    marshallers.put("java.util.Collections$UnmodifiableRandomAccessList", java_util_List);
    marshallers.put("java.util.Collections$UnmodifiableList", java_util_List);
    marshallers.put("java.util.Arrays$ArrayList", java_util_List);
    final ListMarshaller java_util_AbstractList = new ListMarshaller();
    marshallers.put("java.util.AbstractList", java_util_AbstractList);
    final ListMarshaller java_util_ArrayList = new ListMarshaller();
    marshallers.put("java.util.ArrayList", java_util_ArrayList);
    final ListMarshaller java_util_Vector = new ListMarshaller();
    marshallers.put("java.util.Vector", java_util_Vector);
    final ListMarshaller java_util_Stack = new ListMarshaller();
    marshallers.put("java.util.Stack", java_util_Stack);
    final QueueMarshaller java_util_Queue = new QueueMarshaller();
    marshallers.put("java.util.Queue", java_util_Queue);
    marshallers.put("java.util.AbstractQueue", java_util_Queue);
    final QueueMarshaller java_util_AbstractQueue = new QueueMarshaller();
    marshallers.put("java.util.AbstractQueue", java_util_AbstractQueue);
    final ShortMarshaller java_lang_Short = new ShortMarshaller();
    marshallers.put("java.lang.Short", java_lang_Short);
    final OptionalMarshaller java_util_Optional = new OptionalMarshaller();
    marshallers.put("java.util.Optional", java_util_Optional);
    final CharacterMarshaller java_lang_Character = new CharacterMarshaller();
    marshallers.put("java.lang.Character", java_lang_Character);
    final AssignmentDataMarshaller org_kie_workbench_common_stunner_bpmn_client_forms_fields_model_AssignmentData = new AssignmentDataMarshaller();
    marshallers.put("org.kie.workbench.common.stunner.bpmn.client.forms.fields.model.AssignmentData", org_kie_workbench_common_stunner_bpmn_client_forms_fields_model_AssignmentData);
    final StringBufferMarshaller java_lang_StringBuffer = new StringBufferMarshaller();
    marshallers.put("java.lang.StringBuffer", java_lang_StringBuffer);
    final TimeMarshaller java_sql_Time = new TimeMarshaller();
    marshallers.put("java.sql.Time", java_sql_Time);
    final SortedSetMarshaller java_util_SortedSet = new SortedSetMarshaller();
    marshallers.put("java.util.SortedSet", java_util_SortedSet);
    marshallers.put("java.util.TreeSet", java_util_SortedSet);
    marshallers.put("java.util.Collections$UnmodifiableSortedSet", java_util_SortedSet);
    marshallers.put("java.util.Collections$SynchronizedSortedSet", java_util_SortedSet);
    final SortedSetMarshaller java_util_TreeSet = new SortedSetMarshaller();
    marshallers.put("java.util.TreeSet", java_util_TreeSet);
    final PriorityQueueMarshaller java_util_PriorityQueue = new PriorityQueueMarshaller();
    marshallers.put("java.util.PriorityQueue", java_util_PriorityQueue);
  }

  private boolean putMarshaller(String fqcn, Marshaller m) {
    marshallers.put(fqcn, m);
    return true;
  }

  private boolean loadMarshaller0(String a0) {
    switch (a0) {
      case "java.lang.Throwable": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_Throwable.class));
      case "java.lang.ArithmeticException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_ArithmeticException.class));
      case "java.io.IOException": return putMarshaller(a0, GWT.create(Marshaller_for_java_io_IOException.class));
      case "java.lang.IllegalArgumentException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_IllegalArgumentException.class));
      case "java.util.EmptyStackException": return putMarshaller(a0, GWT.create(Marshaller_for_java_util_EmptyStackException.class));
      case "java.lang.ArrayStoreException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_ArrayStoreException.class));
      case "java.lang.ClassCastException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_ClassCastException.class));
      case "java.util.ConcurrentModificationException": return putMarshaller(a0, GWT.create(Marshaller_for_java_util_ConcurrentModificationException.class));
      case "java.lang.IndexOutOfBoundsException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_IndexOutOfBoundsException.class));
      case "java.lang.NegativeArraySizeException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_NegativeArraySizeException.class));
      case "java.lang.NullPointerException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_NullPointerException.class));
      case "java.lang.StringIndexOutOfBoundsException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_StringIndexOutOfBoundsException.class));
      case "java.lang.UnsupportedOperationException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_UnsupportedOperationException.class));
      case "java.lang.AssertionError": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_AssertionError.class));
      case "java.lang.RuntimeException": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_RuntimeException.class));
      case "java.lang.StackTraceElement": return putMarshaller(a0, GWT.create(Marshaller_for_java_lang_StackTraceElement.class));
      case "org.jboss.errai.security.shared.exception.SecurityException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_SecurityException.class));
      case "org.jboss.errai.security.shared.exception.UnauthenticatedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_UnauthenticatedException.class));
      case "org.jboss.errai.security.shared.exception.UnauthorizedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_UnauthorizedException.class));
      case "org.jboss.errai.security.shared.exception.AuthenticationException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_AuthenticationException.class));
      case "org.kie.workbench.common.stunner.bpmn.workitem.IconDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_workitem_IconDefinition.class));
      case "org.guvnor.common.services.project.model.ModuleRepositories": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_ModuleRepositories.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.font.FontFamily": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontFamily.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.BusinessRuleTask": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_BusinessRuleTask.class));
      case "org.guvnor.common.services.project.model.Module": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Module.class));
      case "org.uberfire.ext.plugin.event.MediaAdded": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_MediaAdded.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.CloneConnectorCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_CloneConnectorCommand.class));
      case "org.kie.workbench.common.stunner.core.diagram.MetadataImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_diagram_MetadataImpl.class));
      case "org.uberfire.preferences.shared.bean.PreferenceRootElement": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_bean_PreferenceRootElement.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.BusinessRuleTaskExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_BusinessRuleTaskExecutionSet.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.ReusableSubprocess": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_ReusableSubprocess.class));
      case "org.drools.workbench.models.datamodel.oracle.DSLActionSentence": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_DSLActionSentence.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.connectors.SequenceFlowExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_connectors_SequenceFlowExecutionSet.class));
      case "org.uberfire.workbench.events.ResourceUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceUpdatedEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.font.FontColor": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontColor.class));
      case "org.kie.workbench.common.forms.model.impl.meta.entries.FieldRequiredEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_entries_FieldRequiredEntry.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.diagram.Version": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_Version.class));
      case "org.uberfire.ext.plugin.event.NewPluginRegistered": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_NewPluginRegistered.class));
      case "org.uberfire.workbench.model.Notification$State": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_Notification_erraiD_State.class));
      case "org.guvnor.structure.organizationalunit.impl.OrganizationalUnitImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_impl_OrganizationalUnitImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.background.BackgroundSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_background_BackgroundSet.class));
      case "org.kie.workbench.common.stunner.core.definition.exception.DefinitionNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_exception_DefinitionNotFoundException.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.escalation.CancellingEscalationEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_escalation_CancellingEscalationEventExecutionSet.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.AssigneeEditorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssigneeEditorFieldDefinition.class));
      case "org.uberfire.java.nio.file.NotDirectoryException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_NotDirectoryException.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateMessageEventCatching": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateMessageEventCatching.class));
      case "org.uberfire.mvp.impl.ForcedPlaceRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_mvp_impl_ForcedPlaceRequest.class));
      case "org.uberfire.ext.security.management.api.CapabilityStatus": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_CapabilityStatus.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.ContextOperationNotAllowedViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_ContextOperationNotAllowedViolation.class));
      case "org.ext.uberfire.social.activities.model.DefaultTypes": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_DefaultTypes.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.signal.CancellingSignalEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_CancellingSignalEventExecutionSet.class));
      case "org.guvnor.structure.organizationalunit.RepoRemovedFromOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_RepoRemovedFromOrganizationalUnitEvent.class));
      case "org.drools.workbench.models.datamodel.rule.FromEntryPointFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromEntryPointFactPattern.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.radioGroup.definition.DecimalRadioGroupFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_radioGroup_definition_DecimalRadioGroupFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.timer.TimerSettings": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_timer_TimerSettings.class));
      case "org.uberfire.experimental.service.backend.impl.ExperimentalFeaturesSessionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_backend_impl_ExperimentalFeaturesSessionImpl.class));
      case "org.uberfire.ext.properties.editor.model.PropertyEditorFieldInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorFieldInfo.class));
      case "org.uberfire.workbench.events.ResourceRenamedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceRenamedEvent.class));
      case "org.kie.workbench.common.stunner.core.rule.RuleSetImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_RuleSetImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.ReusableSubprocessTaskExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_ReusableSubprocessTaskExecutionSet.class));
      case "org.drools.workbench.models.datamodel.rule.DSLSentence": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLSentence.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.CloneNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_CloneNodeCommand.class));
      case "org.ext.uberfire.social.activities.model.SocialActivitiesEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialActivitiesEvent.class));
      case "org.kie.workbench.common.forms.model.FormDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_FormDefinition.class));
      case "org.kie.workbench.common.stunner.core.rule.impl.EdgeOccurrences": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_EdgeOccurrences.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.subProcess.execution.EmbeddedSubprocessExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_subProcess_execution_EmbeddedSubprocessExecutionSet.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.datePicker.definition.DatePickerFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_datePicker_definition_DatePickerFieldDefinition.class));
      case "org.uberfire.workbench.model.impl.PartDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_PartDefinitionImpl.class));
      case "org.drools.workbench.models.datamodel.rule.ActionRetractFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionRetractFact.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.DockNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DockNodeCommand.class));
      case "org.jboss.errai.security.shared.exception.FailedAuthenticationException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_FailedAuthenticationException.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.ScriptTypeListFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeListFieldDefinition.class));
      case "org.uberfire.experimental.service.editor.EditableExperimentalFeature": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_editor_EditableExperimentalFeature.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.dimensions.Radius": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_Radius.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.listBox.definition.CharacterListBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_CharacterListBoxFieldDefinition.class));
      case "org.uberfire.ext.services.shared.preferences.UserPreference": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreference.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.MultipleInstanceCompletionCondition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceCompletionCondition.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionFieldVariable": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFieldVariable.class));
      case "org.uberfire.ext.security.management.api.exception.EntityNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_EntityNotFoundException.class));
      case "org.uberfire.workbench.model.ContextDisplayMode": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_ContextDisplayMode.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.MultipleInstanceSubprocess": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_MultipleInstanceSubprocess.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.RuleViolationImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_RuleViolationImpl.class));
      case "org.guvnor.common.services.project.social.ModuleEventType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_social_ModuleEventType.class));
      case "org.kie.workbench.common.forms.dynamic.service.shared.impl.MapModelRenderingContext": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_impl_MapModelRenderingContext.class));
      case "org.uberfire.ext.plugin.event.PluginUnregistered": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginUnregistered.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateEscalationEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateEscalationEvent.class));
      case "org.kie.workbench.common.stunner.core.rule.ext.RuleExtension": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_ext_RuleExtension.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.diagram.DiagramSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_DiagramSet.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutTemplate": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.relations.multipleSubform.definition.MultipleSubFormFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_relations_multipleSubform_definition_MultipleSubFormFieldDefinition.class));
      case "org.guvnor.common.services.project.service.DeploymentMode": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_service_DeploymentMode.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.radioGroup.definition.IntegerRadioGroupFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_radioGroup_definition_IntegerRadioGroupFieldDefinition.class));
      case "org.uberfire.ext.services.shared.preferences.GridPreferencesStore": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_GridPreferencesStore.class));
      case "org.uberfire.workbench.events.ResourceChangeType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceChangeType.class));
      case "org.kie.workbench.common.stunner.core.graph.impl.NodeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_impl_NodeImpl.class));
      case "org.kie.workbench.common.forms.dynamic.model.document.DocumentStatus": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_dynamic_model_document_DocumentStatus.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.WorkingHours": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_WorkingHours.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableBooleanParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableBooleanParameterDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.AssignmentsEditorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssignmentsEditorFieldDefinition.class));
      case "org.uberfire.ext.security.management.impl.SearchResponseImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_SearchResponseImpl.class));
      case "org.kie.workbench.common.stunner.core.lookup.VFSLookupRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_lookup_VFSLookupRequest.class));
      case "org.uberfire.workbench.events.PluginAddedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_PluginAddedEvent.class));
      case "org.uberfire.security.authz.AuthorizationResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_authz_AuthorizationResult.class));
      case "org.kie.workbench.common.stunner.core.definition.impl.DefinitionSetImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_impl_DefinitionSetImpl.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.RemoveParentCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_RemoveParentCommand.class));
      case "org.guvnor.structure.organizationalunit.NewOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_NewOrganizationalUnitEvent.class));
      case "org.uberfire.security.impl.authz.DefaultAuthorizationPolicy": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationPolicy.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.StandardDeviation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_StandardDeviation.class));
      case "org.guvnor.structure.repositories.EnvironmentParameters": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_EnvironmentParameters.class));
      case "org.uberfire.mvp.impl.PathPlaceRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_mvp_impl_PathPlaceRequest.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.dimensions.RectangleDimensionsSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_RectangleDimensionsSet.class));
      case "org.kie.workbench.common.stunner.core.graph.content.definition.DefinitionSetImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_definition_DefinitionSetImpl.class));
      case "org.uberfire.ext.plugin.model.RuntimePlugin": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_RuntimePlugin.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionVariable": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionVariable.class));
      case "org.uberfire.ext.plugin.model.LayoutEditorModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_LayoutEditorModel.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.font.FontSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontSet.class));
      case "org.guvnor.structure.repositories.RepositoryInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryInfo.class));
      case "org.jboss.errai.security.shared.exception.AlreadyLoggedInException": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_exception_AlreadyLoggedInException.class));
      case "org.uberfire.ext.plugin.model.Language": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Language.class));
      case "org.guvnor.common.services.project.builder.model.IncrementalBuildResults": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_model_IncrementalBuildResults.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.dataio.AssignmentsInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dataio_AssignmentsInfo.class));
      case "org.kie.soup.project.datamodel.oracle.DataType$DataTypes": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_DataType_erraiD_DataTypes.class));
      case "org.uberfire.backend.plugin.RuntimePlugin": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_plugin_RuntimePlugin.class));
      case "org.uberfire.experimental.service.definition.ExperimentalFeatureDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_definition_ExperimentalFeatureDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.DistributionType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_DistributionType.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.StartCompensationEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartCompensationEvent.class));
      case "org.guvnor.structure.navigator.DataContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_navigator_DataContent.class));
      case "org.kie.workbench.common.forms.model.impl.PortableJavaModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_impl_PortableJavaModel.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.UpdateDomainObjectPropertyValueCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UpdateDomainObjectPropertyValueCommand.class));
      case "org.guvnor.structure.repositories.RepositoryRemovedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryRemovedEvent.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.slider.definition.IntegerSliderDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_slider_definition_IntegerSliderDefinition.class));
      case "org.kie.workbench.common.stunner.core.rule.EmptyRuleSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_EmptyRuleSet.class));
      case "org.guvnor.common.services.project.builder.events.InvalidateDMOModuleCacheEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOModuleCacheEvent.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.integerBox.definition.IntegerBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_integerBox_definition_IntegerBoxFieldDefinition.class));
      case "org.uberfire.ext.plugin.exception.PluginAlreadyExists": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_exception_PluginAlreadyExists.class));
      case "org.guvnor.common.services.project.security.ProjectResourceType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_security_ProjectResourceType.class));
      case "org.uberfire.preferences.shared.impl.validation.ValidationResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_validation_ValidationResult.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.DeleteNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeleteNodeCommand.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.Mean": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Mean.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.escalation.EscalationEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_escalation_EscalationEventExecutionSet.class));
      case "org.uberfire.backend.vfs.impl.LockInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_LockInfo.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.StartNoneEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartNoneEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.dimensions.CircleDimensionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_CircleDimensionSet.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.relations.subForm.definition.SubFormFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_relations_subForm_definition_SubFormFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseTaskMorphPropertyDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseTaskMorphPropertyDefinition.class));
      case "org.ext.uberfire.social.activities.events.SocialUserUnFollowedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_events_SocialUserUnFollowedEvent.class));
      case "org.kie.workbench.common.stunner.cm.client.command.graph.CaseManagementDeleteElementsCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_cm_client_command_graph_CaseManagementDeleteElementsCommand.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.Lane": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_Lane.class));
      case "org.drools.workbench.models.datamodel.rule.SingleFieldConstraintEBLeftSide": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraintEBLeftSide.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.SetConnectionTargetNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SetConnectionTargetNodeCommand.class));
      case "org.kie.workbench.common.stunner.core.lookup.definition.DefinitionRepresentation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_lookup_definition_DefinitionRepresentation.class));
      case "org.kie.workbench.common.stunner.cm.client.command.graph.CaseManagementAddNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_cm_client_command_graph_CaseManagementAddNodeCommand.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.textBox.definition.TextBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_textBox_definition_TextBoxFieldDefinition.class));
      case "org.guvnor.common.services.workingset.client.model.WorkingSetConfigData": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetConfigData.class));
      case "org.guvnor.structure.repositories.RepositoryEnvironmentConfigurations": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfigurations.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateSignalEventThrowing": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateSignalEventThrowing.class));
      case "org.drools.workbench.models.datamodel.rule.FromCollectCompositeFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCollectCompositeFactPattern.class));
      case "org.uberfire.ext.security.management.impl.UserManagerSettingsImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_UserManagerSettingsImpl.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.SetConnectionSourceNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SetConnectionSourceNodeCommand.class));
      case "org.uberfire.java.nio.file.FileAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileAlreadyExistsException.class));
      case "org.uberfire.ext.plugin.model.Plugin": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Plugin.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.SafeDeleteNodeCommand$Options": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SafeDeleteNodeCommand_erraiD_Options.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.AssigneeEditorFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssigneeEditorFieldType.class));
      case "org.kie.workbench.common.forms.dynamic.service.shared.RenderMode": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_RenderMode.class));
      case "org.drools.workbench.models.datamodel.rule.ActionUpdateField": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionUpdateField.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.listBox.definition.EnumListBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_EnumListBoxFieldDefinition.class));
      case "org.guvnor.common.services.project.model.WorkItemHandlerModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_WorkItemHandlerModel.class));
      case "org.guvnor.common.services.project.events.NewPackageEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_NewPackageEvent.class));
      case "org.kie.workbench.common.stunner.cm.definition.CaseManagementDiagram": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_cm_definition_CaseManagementDiagram.class));
      case "org.uberfire.preferences.shared.impl.DefaultPreferenceScopeResolver": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_DefaultPreferenceScopeResolver.class));
      case "org.kie.workbench.common.forms.model.impl.meta.entries.FieldLabelEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_entries_FieldLabelEntry.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.AddDockedNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddDockedNodeCommand.class));
      case "org.guvnor.common.services.project.model.Plugin": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Plugin.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateConditionalEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateConditionalEvent.class));
      case "org.uberfire.workbench.events.ResourceUpdated": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceUpdated.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.Min": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Min.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.radioGroup.definition.StringRadioGroupFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_radioGroup_definition_StringRadioGroupFieldDefinition.class));
      case "org.kie.workbench.common.services.datamodel.model.PackageDataModelOracleBaselinePayload": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleBaselinePayload.class));
      case "org.drools.workbench.models.datamodel.rule.ActionCallMethod": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionCallMethod.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.selector.impl.BooleanMultipleSelectorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_BooleanMultipleSelectorFieldDefinition.class));
      case "org.kie.soup.project.datamodel.oracle.ModelField": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.AdHocSubprocessTaskExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_AdHocSubprocessTaskExecutionSet.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateTimerEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateTimerEvent.class));
      case "org.guvnor.common.services.shared.metadata.model.DiscussionRecord": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_metadata_model_DiscussionRecord.class));
      case "org.uberfire.backend.vfs.FileSystemFactory$FileSystemImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_FileSystemFactory_erraiD_FileSystemImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.gateway.DefaultRoute": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_gateway_DefaultRoute.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.BPMNDiagramImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_BPMNDiagramImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.type.ScriptTypeList": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_ScriptTypeList.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.StartTimerEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartTimerEvent.class));
      case "org.uberfire.ext.plugin.model.DynamicMenuItem": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenuItem.class));
      case "org.uberfire.ext.properties.editor.model.validators.TextValidator": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_validators_TextValidator.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.CancelActivity": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_CancelActivity.class));
      case "org.drools.workbench.models.datamodel.rule.RuleAttribute": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleAttribute.class));
      case "org.drools.workbench.models.datamodel.rule.ActionWorkItemFieldValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionWorkItemFieldValue.class));
      case "org.kie.workbench.common.services.datamodel.model.PackageDataModelOracleIncrementalPayload": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodel_model_PackageDataModelOracleIncrementalPayload.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.AdHocCompletionCondition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_AdHocCompletionCondition.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.cm.RolesEditorFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_cm_RolesEditorFieldType.class));
      case "org.jboss.errai.security.shared.api.RoleImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_api_RoleImpl.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableFloatParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableFloatParameterDefinition.class));
      case "org.guvnor.common.services.project.builder.events.InvalidateDMOPackageCacheEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_events_InvalidateDMOPackageCacheEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseNonContainerSubprocessMorphDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseNonContainerSubprocessMorphDefinition.class));
      case "org.uberfire.preferences.shared.impl.PreferenceScopedValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopedValue.class));
      case "org.uberfire.workbench.events.ResourceOpenedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceOpenedEvent.class));
      case "org.guvnor.structure.organizationalunit.RepoAddedToOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_RepoAddedToOrganizationalUnitEvent.class));
      case "org.kie.workbench.common.stunner.core.preferences.StunnerPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_preferences_StunnerPreferencesPortableGeneratedImpl.class));
      case "org.guvnor.common.services.shared.validation.model.ValidationMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_validation_model_ValidationMessage.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.UpdateElementPropertyValueCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UpdateElementPropertyValueCommand.class));
      case "org.kie.workbench.common.stunner.core.command.impl.CommandResultImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_command_impl_CommandResultImpl.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.AddChildNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddChildNodeCommand.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.MultipleInstanceSubprocessTaskExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceSubprocessTaskExecutionSet.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.compensation.CompensationEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_compensation_CompensationEventExecutionSet.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseTaskMorphPropertyDefinition$TaskTypeMorphProperty": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseTaskMorphPropertyDefinition_erraiD_TaskTypeMorphProperty.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.StartMessageEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartMessageEvent.class));
      case "org.uberfire.preferences.shared.bean.PreferenceHierarchyElement": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_bean_PreferenceHierarchyElement.class));
      case "org.uberfire.ext.security.management.impl.GroupManagerSettingsImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_GroupManagerSettingsImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.Association": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_Association.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.variables.ProcessData": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_variables_ProcessData.class));
      case "org.jboss.errai.common.client.PageRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_common_client_PageRequest.class));
      case "org.kie.workbench.common.forms.model.impl.meta.entries.FieldTypeEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_entries_FieldTypeEntry.class));
      case "org.kie.workbench.common.stunner.core.command.impl.DeferredCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_command_impl_DeferredCommand.class));
      case "org.kie.workbench.common.stunner.bpmn.service.ProjectType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_service_ProjectType.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.MITrigger": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MITrigger.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateSignalEventCatching": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateSignalEventCatching.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.general.Name": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_general_Name.class));
      case "org.uberfire.ext.plugin.event.PluginSaved": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginSaved.class));
      case "org.guvnor.structure.organizationalunit.OrganizationalUnitEventBase": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_OrganizationalUnitEventBase.class));
      case "org.uberfire.experimental.service.registry.impl.ExperimentalFeaturesRegistryImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_registry_impl_ExperimentalFeaturesRegistryImpl.class));
      case "org.uberfire.ext.editor.commons.file.exports.PdfExportPreferences$Format": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Format.class));
      case "org.kie.workbench.common.stunner.core.lookup.diagram.DiagramLookupRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_lookup_diagram_DiagramLookupRequest.class));
      case "org.uberfire.backend.vfs.impl.DirectoryStreamImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_DirectoryStreamImpl.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionMethodParameter": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameter.class));
      case "org.drools.workbench.models.datamodel.rule.CompositeFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFactPattern.class));
      case "org.uberfire.workbench.events.UberfireJSAPIReadyEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_UberfireJSAPIReadyEvent.class));
      case "org.uberfire.paging.PageRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_paging_PageRequest.class));
      case "org.kie.workbench.common.stunner.core.graph.content.view.ViewConnectorImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_ViewConnectorImpl.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.UpdateControlPointPositionCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UpdateControlPointPositionCommand.class));
      case "org.kie.workbench.common.stunner.core.definition.property.type.IntegerType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_IntegerType.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.ClearGraphCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_ClearGraphCommand.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.type.TimerSettingsType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_TimerSettingsType.class));
      case "org.uberfire.ext.security.management.impl.UserAttributeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_UserAttributeImpl.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.input.impl.StringMultipleInputFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_StringMultipleInputFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.Quantity": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Quantity.class));
      case "org.guvnor.common.services.project.model.ModuleRepositories$ModuleRepository": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_ModuleRepositories_erraiD_ModuleRepository.class));
      case "org.guvnor.common.services.project.builder.model.BuildMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_model_BuildMessage.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.AddControlPointCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddControlPointCommand.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.MultipleInstanceDataOutput": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceDataOutput.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.ScriptTypeListFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeListFieldType.class));
      case "org.uberfire.workbench.model.impl.PanelDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_PanelDefinitionImpl.class));
      case "org.drools.workbench.models.datamodel.rule.DSLVariableValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLVariableValue.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.general.Documentation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_general_Documentation.class));
      case "org.guvnor.common.services.project.service.PackageAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_service_PackageAlreadyExistsException.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseSubprocessMorphDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseSubprocessMorphDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.timer.TimerSettingsValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_timer_TimerSettingsValue.class));
      case "org.kie.workbench.common.stunner.cm.definition.EmbeddedSubprocess": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_cm_definition_EmbeddedSubprocess.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.CalledElement": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_CalledElement.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseThrowingIntermediateEventMorphDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseThrowingIntermediateEventMorphDefinition.class));
      case "org.jboss.errai.security.shared.api.identity.UserImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_api_identity_UserImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.error.InterruptingErrorEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_error_InterruptingErrorEventExecutionSet.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.DeleteElementsCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeleteElementsCommand.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.MultipleInstanceCollectionOutput": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceCollectionOutput.class));
      case "org.uberfire.workbench.model.Notification": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_Notification.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.ScriptTypeFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeFieldType.class));
      case "org.guvnor.common.services.project.model.POM": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_POM.class));
      case "org.kie.workbench.common.forms.dynamic.service.shared.impl.validation.DynamicModelConstraints": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_impl_validation_DynamicModelConstraints.class));
      case "org.guvnor.structure.repositories.impl.GitMetadataImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_GitMetadataImpl.class));
      case "org.kie.workbench.common.stunner.core.graph.content.view.MagnetConnection": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_MagnetConnection.class));
      case "org.uberfire.backend.events.AuthorizationPolicySavedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_events_AuthorizationPolicySavedEvent.class));
      case "org.guvnor.common.services.project.model.MavenRepository": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_MavenRepository.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.EdgeCardinalityMinRuleViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_EdgeCardinalityMinRuleViolation.class));
      case "org.guvnor.common.services.project.model.MavenRepositorySource": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_MavenRepositorySource.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.Skippable": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Skippable.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.StringSelectorOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_StringSelectorOption.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionMethod": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethod.class));
      case "org.kie.workbench.common.stunner.core.graph.content.relationship.Dock": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_relationship_Dock.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.CardinalityMinRuleViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_CardinalityMinRuleViolation.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.DefaultRuleViolations": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_DefaultRuleViolations.class));
      case "org.kie.workbench.common.stunner.core.rule.impl.CanDock": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_CanDock.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.ScriptTypeListValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_ScriptTypeListValue.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.Independent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Independent.class));
      case "org.kie.workbench.common.stunner.core.definition.morph.MorphDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_morph_MorphDefinitionImpl.class));
      case "org.uberfire.workbench.events.PluginReloadedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_PluginReloadedEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.type.TaskPropertyType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_TaskPropertyType.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.UpdateElementPositionCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UpdateElementPositionCommand.class));
      case "org.ext.uberfire.social.activities.model.PagedSocialQuery": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_PagedSocialQuery.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateMessageEventThrowing": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateMessageEventThrowing.class));
      case "org.kie.workbench.common.stunner.core.lookup.rule.RuleLookupRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_lookup_rule_RuleLookupRequest.class));
      case "org.uberfire.ext.apps.api.DirectoryBreadcrumb": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_apps_api_DirectoryBreadcrumb.class));
      case "org.uberfire.workbench.events.ResourceRenamed": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceRenamed.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.subProcess.execution.EventSubprocessExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_subProcess_execution_EventSubprocessExecutionSet.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.message.CancellingMessageEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_message_CancellingMessageEventExecutionSet.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionMethodParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionMethodParameterDefinition.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.EmptyConnectionViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_EmptyConnectionViolation.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.message.MessageEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_message_MessageEventExecutionSet.class));
      case "org.kie.soup.project.datamodel.imports.Imports": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_imports_Imports.class));
      case "org.kie.workbench.common.stunner.core.rule.impl.Occurrences": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_Occurrences.class));
      case "org.guvnor.common.services.workingset.client.model.WorkingSetSettings": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_workingset_client_model_WorkingSetSettings.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.Subject": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Subject.class));
      case "org.uberfire.ext.plugin.model.DynamicMenu": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_DynamicMenu.class));
      case "org.uberfire.ext.plugin.model.PluginSimpleContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_PluginSimpleContent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.UserTask": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_UserTask.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.escalation.EscalationRef": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_escalation_EscalationRef.class));
      case "org.uberfire.ext.security.management.api.exception.RealmManagementNotAuthorizedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_RealmManagementNotAuthorizedException.class));
      case "org.kie.workbench.common.stunner.core.definition.clone.ClonePolicy": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_clone_ClonePolicy.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.diagram.Package": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_Package.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.IntegerSelectorOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_IntegerSelectorOption.class));
      case "org.uberfire.ext.apps.api.Directory": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_apps_api_Directory.class));
      case "org.guvnor.structure.repositories.Branch": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_Branch.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.CreatedBy": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_CreatedBy.class));
      case "org.guvnor.structure.repositories.RepositoryNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryNotFoundException.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.background.BorderSize": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_background_BorderSize.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.relations.Container": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_relations_Container.class));
      case "org.drools.workbench.models.datamodel.auditlog.AuditLog": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_auditlog_AuditLog.class));
      case "org.kie.soup.project.datamodel.oracle.ModelField$FIELD_CLASS_TYPE": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_CLASS_erraiU_TYPE.class));
      case "org.kie.workbench.common.stunner.core.lookup.diagram.DiagramRepresentation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_lookup_diagram_DiagramRepresentation.class));
      case "org.kie.workbench.common.stunner.core.graph.content.view.ViewImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_ViewImpl.class));
      case "org.drools.workbench.models.datamodel.rule.FreeFormLine": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FreeFormLine.class));
      case "org.guvnor.common.services.project.model.ProjectImports": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_ProjectImports.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.diagram.ProcessInstanceDescription": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_ProcessInstanceDescription.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.timer.CancellingTimerEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_timer_CancellingTimerEventExecutionSet.class));
      case "org.drools.workbench.models.datamodel.rule.RuleModel": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleModel.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.SequenceFlow": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_SequenceFlow.class));
      case "org.kie.soup.project.datamodel.oracle.DataType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_DataType.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.font.FontBorderColor": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontBorderColor.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.type.AssignmentsType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_AssignmentsType.class));
      case "org.guvnor.common.services.project.events.DeleteModuleEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_DeleteModuleEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.diagram.Id": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_Id.class));
      case "org.uberfire.ext.editor.commons.version.impl.PortableVersionRecord": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_version_impl_PortableVersionRecord.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.VariablesEditorFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_VariablesEditorFieldType.class));
      case "org.drools.workbench.models.datamodel.rule.ActionFieldFunction": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldFunction.class));
      case "org.jboss.errai.security.shared.api.GroupImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_jboss_errai_security_shared_api_GroupImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.signal.SignalRef": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_SignalRef.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.IsAsync": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_IsAsync.class));
      case "org.kie.workbench.common.stunner.cm.client.command.graph.CaseManagementRemoveChildCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_cm_client_command_graph_CaseManagementRemoveChildCommand.class));
      case "org.kie.workbench.common.forms.model.impl.TypeInfoImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_impl_TypeInfoImpl.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.textArea.definition.TextAreaFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_textArea_definition_TextAreaFieldDefinition.class));
      case "org.guvnor.common.services.project.model.Build": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Build.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.selector.impl.DecimalMultipleSelectorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_DecimalMultipleSelectorFieldDefinition.class));
      case "org.ext.uberfire.social.activities.model.SocialUser": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialUser.class));
      case "org.uberfire.ext.services.shared.preferences.GridColumnPreference": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_GridColumnPreference.class));
      case "org.kie.workbench.common.stunner.core.graph.impl.GraphImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_impl_GraphImpl.class));
      case "org.uberfire.ext.plugin.event.PluginDeleted": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginDeleted.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.ConditionalComboBoxFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ConditionalComboBoxFieldType.class));
      case "org.uberfire.workbench.events.PluginUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_PluginUpdatedEvent.class));
      case "org.guvnor.common.services.project.model.GAV": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_GAV.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableObjectParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableObjectParameterDefinition.class));
      case "org.uberfire.workbench.events.ResourceDeletedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceDeletedEvent.class));
      case "org.drools.workbench.models.datamodel.rule.FactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FactPattern.class));
      case "org.uberfire.java.nio.file.ClosedWatchServiceException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_ClosedWatchServiceException.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableIntegerParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableIntegerParameterDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.dimensions.Height": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_Height.class));
      case "org.guvnor.common.services.project.events.ModuleUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_ModuleUpdatedEvent.class));
      case "org.uberfire.ext.editor.commons.file.exports.PdfExportPreferences$Unit": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Unit.class));
      case "org.uberfire.ext.security.management.api.exception.UserAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_UserAlreadyExistsException.class));
      case "org.kie.workbench.common.stunner.core.definition.impl.PropertySetImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_impl_PropertySetImpl.class));
      case "org.uberfire.workbench.model.CompassPosition": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_CompassPosition.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionFormLine": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionFormLine.class));
      case "org.guvnor.common.services.project.model.MavenRepositoryMetadata": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_MavenRepositoryMetadata.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableStringParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableStringParameterDefinition.class));
      case "org.uberfire.workbench.model.NamedPosition": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_NamedPosition.class));
      case "org.guvnor.structure.navigator.NavigatorContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_navigator_NavigatorContent.class));
      case "org.uberfire.ext.security.management.api.exception.UserNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_UserNotFoundException.class));
      case "org.kie.workbench.common.stunner.cm.definition.AdHocSubprocess": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_cm_definition_AdHocSubprocess.class));
      case "org.guvnor.common.services.project.events.NewProjectEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_NewProjectEvent.class));
      case "org.guvnor.common.services.project.model.Dependency": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Dependency.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.cm.CaseFileVariables": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_cm_CaseFileVariables.class));
      case "org.kie.workbench.common.stunner.core.graph.content.view.Point2D": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_Point2D.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.checkBox.definition.CheckBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_checkBox_definition_CheckBoxFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.EndEscalationEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndEscalationEvent.class));
      case "org.uberfire.experimental.service.security.GlobalExperimentalFeatureResourceType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_security_GlobalExperimentalFeatureResourceType.class));
      case "org.kie.workbench.common.stunner.core.lookup.definition.DefinitionLookupRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_lookup_definition_DefinitionLookupRequest.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.dataio.DataIOSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dataio_DataIOSet.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseTaskMorphDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseTaskMorphDefinition.class));
      case "org.kie.workbench.common.stunner.core.validation.impl.ModelBeanViolationImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_validation_impl_ModelBeanViolationImpl.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.DeleteConnectorCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeleteConnectorCommand.class));
      case "org.uberfire.ext.security.management.impl.RoleManagerSettingsImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_RoleManagerSettingsImpl.class));
      case "org.uberfire.ext.editor.commons.file.exports.FileExportsPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_FileExportsPreferencesPortableGeneratedImpl.class));
      case "org.kie.workbench.common.stunner.forms.context.PathAwareFormContext": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_forms_context_PathAwareFormContext.class));
      case "org.ext.uberfire.social.activities.model.SocialFileSelectedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialFileSelectedEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.background.BgColor": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_background_BgColor.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.ScriptTypeFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeFieldDefinition.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.RemoveChildCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_RemoveChildCommand.class));
      case "org.kie.workbench.common.stunner.core.command.impl.DeferredCompositeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_command_impl_DeferredCompositeCommand.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutComponent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutComponent.class));
      case "org.uberfire.ext.plugin.model.PluginContent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_PluginContent.class));
      case "org.kie.workbench.common.stunner.core.graph.impl.EdgeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_impl_EdgeImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.workitem.WorkItemDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_workitem_WorkItemDefinition.class));
      case "org.drools.workbench.models.datamodel.rule.ActionInsertFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertFact.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.signal.InterruptingSignalEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_InterruptingSignalEventExecutionSet.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.radioGroup.definition.CharacterRadioGroupFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_radioGroup_definition_CharacterRadioGroupFieldDefinition.class));
      case "org.drools.workbench.models.datamodel.rule.ConnectiveConstraint": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ConnectiveConstraint.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionText": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionText.class));
      case "org.kie.workbench.common.stunner.core.graph.content.view.ControlPoint": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_ControlPoint.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.InclusiveGateway": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_InclusiveGateway.class));
      case "org.uberfire.java.nio.file.FileSystemAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileSystemAlreadyExistsException.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.input.impl.DecimalMultipleInputFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_DecimalMultipleInputFieldDefinition.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.listBox.definition.StringListBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_StringListBoxFieldDefinition.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionCollectionIndex": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollectionIndex.class));
      case "org.drools.workbench.models.datamodel.oracle.DSLConditionSentence": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_oracle_DSLConditionSentence.class));
      case "org.uberfire.ext.plugin.event.PluginAdded": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginAdded.class));
      case "org.kie.workbench.common.stunner.core.validation.impl.ElementViolationImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_validation_impl_ElementViolationImpl.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.input.impl.IntegerMultipleInputFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_IntegerMultipleInputFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.EndCompensationEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndCompensationEvent.class));
      case "org.kie.workbench.common.stunner.cm.definition.ReusableSubprocess": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_cm_definition_ReusableSubprocess.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionGlobalVariable": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionGlobalVariable.class));
      case "org.uberfire.java.nio.file.FileSystemNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileSystemNotFoundException.class));
      case "org.guvnor.structure.repositories.RepositoryEnvironmentUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentUpdatedEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.common.ConditionExpression": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_common_ConditionExpression.class));
      case "org.drools.workbench.models.datamodel.rule.FromAccumulateCompositeFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromAccumulateCompositeFactPattern.class));
      case "org.kie.workbench.common.forms.dynamic.service.shared.impl.StaticModelFormRenderingContext": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_impl_StaticModelFormRenderingContext.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.ScriptTypeValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_ScriptTypeValue.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.input.impl.CharacterMultipleInputFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_CharacterMultipleInputFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.TimeUnit": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_TimeUnit.class));
      case "org.guvnor.structure.security.RepositoryResourceType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_security_RepositoryResourceType.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.NoneTask": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_NoneTask.class));
      case "org.kie.workbench.common.stunner.core.graph.content.view.Point2DConnection": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_Point2DConnection.class));
      case "org.kie.workbench.common.forms.dynamic.model.config.SelectorData": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_dynamic_model_config_SelectorData.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseCatchingIntermediateEventMorphDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseCatchingIntermediateEventMorphDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.AdHocAutostart": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_AdHocAutostart.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.error.ErrorRef": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_error_ErrorRef.class));
      case "org.kie.soup.project.datamodel.oracle.DropDownData": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_DropDownData.class));
      case "org.uberfire.experimental.service.registry.impl.ExperimentalFeatureImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_registry_impl_ExperimentalFeatureImpl.class));
      case "org.guvnor.common.services.project.model.Package": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Package.class));
      case "org.kie.soup.project.datamodel.imports.Import": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_imports_Import.class));
      case "org.uberfire.ext.security.management.api.exception.InvalidEntityIdentifierException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_InvalidEntityIdentifierException.class));
      case "org.kie.workbench.common.stunner.core.definition.property.type.StringType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_StringType.class));
      case "org.uberfire.ssh.service.shared.editor.PortableSSHPublicKey": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ssh_service_shared_editor_PortableSSHPublicKey.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.font.FontBorderSize": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontBorderSize.class));
      case "org.kie.workbench.common.stunner.core.preferences.StunnerDiagramEditorPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_preferences_StunnerDiagramEditorPreferencesPortableGeneratedImpl.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.selector.impl.CharacterMultipleSelectorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_CharacterMultipleSelectorFieldDefinition.class));
      case "org.guvnor.common.services.shared.metadata.model.Overview": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_metadata_model_Overview.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.type.AssigneeType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_AssigneeType.class));
      case "org.kie.workbench.common.stunner.core.definition.property.type.DoubleType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_DoubleType.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.selector.impl.StringMultipleSelectorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_StringMultipleSelectorFieldDefinition.class));
      case "org.kie.workbench.common.stunner.forms.model.ColorPickerFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_forms_model_ColorPickerFieldDefinition.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.BoundsExceededViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_BoundsExceededViolation.class));
      case "org.uberfire.java.nio.file.DirectoryNotEmptyException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_DirectoryNotEmptyException.class));
      case "org.drools.workbench.models.datamodel.rule.CEPWindow": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_CEPWindow.class));
      case "org.guvnor.structure.security.OrgUnitResourceType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_security_OrgUnitResourceType.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionCollection": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionCollection.class));
      case "org.guvnor.common.services.project.preferences.GeneralPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_preferences_GeneralPreferencesPortableGeneratedImpl.class));
      case "org.uberfire.experimental.service.events.PortableExperimentalFeatureModifiedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_experimental_service_events_PortableExperimentalFeatureModifiedEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.EventSubprocess": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EventSubprocess.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.AddNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddNodeCommand.class));
      case "org.uberfire.ext.plugin.model.CodeType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_CodeType.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.message.MessageRef": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_message_MessageRef.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.ParallelGateway": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_ParallelGateway.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.ComboBoxFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ComboBoxFieldType.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.general.TaskGeneralSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_general_TaskGeneralSet.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableWorkDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableWorkDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.EmptyTaskExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_EmptyTaskExecutionSet.class));
      case "org.kie.workbench.common.stunner.core.rule.impl.CanConnect$PermittedConnection": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_CanConnect_erraiD_PermittedConnection.class));
      case "org.guvnor.structure.repositories.impl.PullRequestImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_PullRequestImpl.class));
      case "org.drools.workbench.models.datamodel.rule.FromCompositeFactPattern": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_FromCompositeFactPattern.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.Script": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Script.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.CharacterSelectorOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_CharacterSelectorOption.class));
      case "org.uberfire.preferences.shared.PropertyFormOptions": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_PropertyFormOptions.class));
      case "org.uberfire.ext.security.management.impl.SettingsImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_SettingsImpl.class));
      case "org.drools.workbench.models.datamodel.rule.ActionSetField": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionSetField.class));
      case "org.uberfire.workbench.model.impl.ContextDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_ContextDefinitionImpl.class));
      case "org.uberfire.preferences.shared.impl.PreferenceScopeImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopeImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.StartErrorEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartErrorEvent.class));
      case "org.uberfire.workbench.events.ResourceAdded": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceAdded.class));
      case "org.uberfire.backend.vfs.impl.LockResult": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_LockResult.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.cm.CaseManagementSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_cm_CaseManagementSet.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.AdHocSubprocess": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_AdHocSubprocess.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutTemplate$Style": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutTemplate_erraiD_Style.class));
      case "org.kie.workbench.common.forms.model.impl.ModelPropertyImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_impl_ModelPropertyImpl.class));
      case "org.uberfire.ext.services.shared.preferences.UserWorkbenchPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_UserWorkbenchPreferences.class));
      case "org.guvnor.common.services.project.context.WorkspaceProjectContextChangeEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_context_WorkspaceProjectContextChangeEvent.class));
      case "org.uberfire.java.nio.file.InvalidPathException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_InvalidPathException.class));
      case "org.drools.workbench.models.datamodel.rule.visitors.RuleModelVisitor": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_RuleModelVisitor.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.cm.CaseRoles": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_cm_CaseRoles.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.SafeDeleteNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SafeDeleteNodeCommand.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutColumn": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutColumn.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.message.InterruptingMessageEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_message_InterruptingMessageEventExecutionSet.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.SimulationAttributeSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_SimulationAttributeSet.class));
      case "org.guvnor.structure.repositories.RepositoryAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryAlreadyExistsException.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.input.impl.BooleanMultipleInputFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_BooleanMultipleInputFieldDefinition.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.ContainmentRuleViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_ContainmentRuleViolation.class));
      case "org.drools.workbench.models.datamodel.rule.ActionGlobalCollectionAdd": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionGlobalCollectionAdd.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.type.VariablesType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_VariablesType.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionField": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionField.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.image.definition.PictureSize": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_image_definition_PictureSize.class));
      case "org.uberfire.java.nio.file.NoSuchFileException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_NoSuchFileException.class));
      case "org.kie.workbench.common.stunner.core.definition.property.type.BooleanType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_BooleanType.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.decimalBox.definition.DecimalBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_decimalBox_definition_DecimalBoxFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.compensation.ActivityRef": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_compensation_ActivityRef.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateCompensationEventThrowing": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateCompensationEventThrowing.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.StartSignalEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartSignalEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.WaitForCompletion": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_WaitForCompletion.class));
      case "org.kie.workbench.common.forms.model.TypeKind": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_TypeKind.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.MultipleInstanceCollectionInput": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceCollectionInput.class));
      case "org.drools.workbench.models.datamodel.auditlog.DefaultAuditLogFilter": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_auditlog_DefaultAuditLogFilter.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.RuleFlowGroup": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_RuleFlowGroup.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.connectors.Priority": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_connectors_Priority.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.Currency": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Currency.class));
      case "org.uberfire.workbench.model.impl.SplashScreenFilterImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_SplashScreenFilterImpl.class));
      case "org.guvnor.common.services.shared.metadata.model.Metadata": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_metadata_model_Metadata.class));
      case "org.uberfire.spaces.Space": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_spaces_Space.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.gateway.GatewayExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_gateway_GatewayExecutionSet.class));
      default: return false;
    }
  }

  private boolean loadMarshaller1(String a0) {
    switch (a0) {
      case "org.guvnor.structure.repositories.RepositoryExternalUpdateEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryExternalUpdateEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.signal.ScopedSignalEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_ScopedSignalEventExecutionSet.class));
      case "org.drools.workbench.models.datamodel.rule.visitors.CopyExpressionVisitor": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_visitors_CopyExpressionVisitor.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.selector.impl.DateMultipleSelectorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_DateMultipleSelectorFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.type.ScriptType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_type_ScriptType.class));
      case "org.uberfire.ext.editor.commons.file.exports.PdfExportPreferences$Orientation": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences_erraiD_Orientation.class));
      case "org.drools.workbench.models.datamodel.rule.InterpolationVariable": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_InterpolationVariable.class));
      case "org.guvnor.structure.organizationalunit.UpdatedOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_UpdatedOrganizationalUnitEvent.class));
      case "org.guvnor.structure.organizationalunit.RemoveOrganizationalUnitEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_organizationalunit_RemoveOrganizationalUnitEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.TaskTypes": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_TaskTypes.class));
      case "org.drools.workbench.models.datamodel.rule.RuleMetadata": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_RuleMetadata.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.listBox.definition.IntegerListBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_IntegerListBoxFieldDefinition.class));
      case "org.drools.workbench.models.datamodel.imports.Import": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_imports_Import.class));
      case "org.uberfire.java.nio.file.NotLinkException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_NotLinkException.class));
      case "org.drools.workbench.models.datamodel.rule.ActionFieldValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionFieldValue.class));
      case "org.kie.soup.project.datamodel.oracle.OperatorsOracle": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_OperatorsOracle.class));
      case "org.guvnor.common.services.shared.exceptions.GenericPortableException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_exceptions_GenericPortableException.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.StartEscalationEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartEscalationEvent.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.DeregisterNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeregisterNodeCommand.class));
      case "org.guvnor.common.services.project.builder.model.BuildResults": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_builder_model_BuildResults.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateEscalationEventThrowing": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateEscalationEventThrowing.class));
      case "org.kie.workbench.common.stunner.core.domainobject.DefaultDomainObject": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_domainobject_DefaultDomainObject.class));
      case "org.guvnor.structure.repositories.impl.DefaultPublicURI": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_DefaultPublicURI.class));
      case "org.kie.workbench.common.stunner.core.diagram.DiagramImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_diagram_DiagramImpl.class));
      case "org.uberfire.paging.PageResponse": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_paging_PageResponse.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.StartConditionalEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_StartConditionalEvent.class));
      case "org.uberfire.java.nio.file.ProviderNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_ProviderNotFoundException.class));
      case "org.uberfire.ext.plugin.model.Media": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Media.class));
      case "org.guvnor.common.services.project.preferences.GAVPreferencesPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_preferences_GAVPreferencesPortableGeneratedImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.Description": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_Description.class));
      case "org.kie.workbench.common.forms.dynamic.service.shared.impl.validation.FieldConstraint": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_dynamic_service_shared_impl_validation_FieldConstraint.class));
      case "org.guvnor.common.services.shared.test.TestResultMessage": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_test_TestResultMessage.class));
      case "org.ext.uberfire.social.activities.model.SocialPaged$Direction": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialPaged_erraiD_Direction.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.AssignmentsEditorFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssignmentsEditorFieldType.class));
      case "org.kie.workbench.common.stunner.bpmn.validation.BPMNViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_validation_BPMNViolation.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.input.impl.DateMultipleInputFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_input_impl_DateMultipleInputFieldDefinition.class));
      case "org.kie.workbench.common.forms.dynamic.model.document.DocumentData": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_dynamic_model_document_DocumentData.class));
      case "org.uberfire.java.nio.file.PatternSyntaxException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_PatternSyntaxException.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.DeleteControlPointCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_DeleteControlPointCommand.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.UnitCost": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_UnitCost.class));
      case "org.uberfire.workbench.events.ResourceAddedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceAddedEvent.class));
      case "org.drools.workbench.models.datamodel.rule.ActionInsertLogicalFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionInsertLogicalFact.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.background.BorderColor": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_background_BorderColor.class));
      case "org.kie.soup.project.datamodel.oracle.ModelField$FIELD_ORIGIN": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_ModelField_erraiD_FIELD_erraiU_ORIGIN.class));
      case "org.kie.workbench.common.stunner.core.definition.impl.DefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_impl_DefinitionImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.OnEntryAction": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_OnEntryAction.class));
      case "org.kie.workbench.common.stunner.core.graph.content.relationship.Child": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_relationship_Child.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.cm.RolesEditorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_cm_RolesEditorFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.EmbeddedSubprocess": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EmbeddedSubprocess.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.EndMessageEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndMessageEvent.class));
      case "org.kie.workbench.common.stunner.core.graph.content.definition.DefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_definition_DefinitionImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.assignee.Actors": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_assignee_Actors.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.ConnectionRuleViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_ConnectionRuleViolation.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.textBox.definition.CharacterBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_textBox_definition_CharacterBoxFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.AdHocOrdering": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_AdHocOrdering.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.ComboBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ComboBoxFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.signal.SignalScope": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_signal_SignalScope.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.ConditionalComboBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ConditionalComboBoxFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.timer.InterruptingTimerEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_timer_InterruptingTimerEventExecutionSet.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.TimerSettingsFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_TimerSettingsFieldDefinition.class));
      case "org.uberfire.workbench.events.ResourceCopiedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceCopiedEvent.class));
      case "org.uberfire.java.nio.IOException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_IOException.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.EndErrorEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndErrorEvent.class));
      case "org.kie.workbench.common.stunner.core.graph.content.relationship.Parent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_relationship_Parent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseEndEventMorphDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseEndEventMorphDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.EndNoneEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndNoneEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.escalation.InterruptingEscalationEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_escalation_InterruptingEscalationEventExecutionSet.class));
      case "org.uberfire.ext.properties.editor.model.validators.LongValidator": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_validators_LongValidator.class));
      case "org.kie.workbench.common.stunner.forms.service.FormGeneratedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_forms_service_FormGeneratedEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.diagram.AdHoc": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_AdHoc.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseStartEventMorphDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseStartEventMorphDefinition.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.UnDockNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_UnDockNodeCommand.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.lists.selector.impl.IntegerMultipleSelectorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_lists_selector_impl_IntegerMultipleSelectorFieldDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.morph.BaseGatewayMorphDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_morph_BaseGatewayMorphDefinition.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.assignee.Groupid": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_assignee_Groupid.class));
      case "org.uberfire.ext.plugin.event.PluginRenamed": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_PluginRenamed.class));
      case "org.uberfire.ext.editor.commons.readonly.ReadOnlyPathPlaceRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_readonly_ReadOnlyPathPlaceRequest.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateErrorEventCatching": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateErrorEventCatching.class));
      case "org.guvnor.structure.repositories.impl.git.GitRepository": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_impl_git_GitRepository.class));
      case "org.uberfire.security.impl.authz.DefaultPermissionCollection": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DefaultPermissionCollection.class));
      case "org.guvnor.structure.repositories.RepositoryEnvironmentConfiguration": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryEnvironmentConfiguration.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.TaskType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_TaskType.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.variables.ProcessVariables": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_variables_ProcessVariables.class));
      case "org.drools.workbench.models.datamodel.rule.DSLComplexVariableValue": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_DSLComplexVariableValue.class));
      case "org.kie.workbench.common.stunner.core.graph.content.view.BoundsImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_BoundsImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.IntermediateCompensationEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_IntermediateCompensationEvent.class));
      case "org.uberfire.mvp.impl.DefaultPlaceRequest": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_mvp_impl_DefaultPlaceRequest.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.error.ErrorEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_error_ErrorEventExecutionSet.class));
      case "org.uberfire.workbench.events.ResourceDeleted": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceDeleted.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.general.BPMNGeneralSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_general_BPMNGeneralSet.class));
      case "org.guvnor.common.services.project.model.Dependencies": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_Dependencies.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.OnExitAction": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_OnExitAction.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.dimensions.Width": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_dimensions_Width.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.EnumSelectorOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_EnumSelectorOption.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.conditional.InterruptingConditionalEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_conditional_InterruptingConditionalEventExecutionSet.class));
      case "org.kie.workbench.common.stunner.core.graph.content.view.BoundImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_content_view_BoundImpl.class));
      case "org.kie.workbench.common.stunner.cm.client.command.graph.CaseManagementSafeDeleteNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_cm_client_command_graph_CaseManagementSafeDeleteNodeCommand.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.DecimalSelectorOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_DecimalSelectorOption.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.conditional.CancellingConditionalEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_conditional_CancellingConditionalEventExecutionSet.class));
      case "org.drools.workbench.models.datamodel.rule.SingleFieldConstraint": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_SingleFieldConstraint.class));
      case "org.uberfire.workbench.events.ResourceCopied": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceCopied.class));
      case "org.uberfire.security.impl.authz.DotNamedPermission": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DotNamedPermission.class));
      case "org.kie.soup.project.datamodel.oracle.TypeSource": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_TypeSource.class));
      case "org.uberfire.ext.security.management.api.exception.NoImplementationAvailableException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_NoImplementationAvailableException.class));
      case "org.uberfire.ext.security.management.api.exception.SecurityManagementException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_SecurityManagementException.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.ExclusiveGateway": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_ExclusiveGateway.class));
      case "org.drools.workbench.models.datamodel.rule.ExpressionUnboundFact": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ExpressionUnboundFact.class));
      case "org.guvnor.structure.social.OrganizationalUnitEventType": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_social_OrganizationalUnitEventType.class));
      case "org.kie.workbench.common.stunner.core.lookup.LookupResponseImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_lookup_LookupResponseImpl.class));
      case "org.kie.workbench.common.stunner.core.definition.property.type.EnumType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_EnumType.class));
      case "org.kie.workbench.common.stunner.bpmn.workitem.ServiceTask": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_workitem_ServiceTask.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.ScriptTaskExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_ScriptTaskExecutionSet.class));
      case "org.kie.workbench.common.stunner.forms.service.FormGenerationFailureEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_forms_service_FormGenerationFailureEvent.class));
      case "org.guvnor.common.services.project.events.NewModuleEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_events_NewModuleEvent.class));
      case "org.guvnor.common.services.project.model.WorkspaceProject": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_model_WorkspaceProject.class));
      case "org.guvnor.structure.repositories.NewRepositoryEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_NewRepositoryEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.diagram.Executable": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_diagram_Executable.class));
      case "org.kie.workbench.common.services.datamodel.model.LazyModelField": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_services_datamodel_model_LazyModelField.class));
      case "org.uberfire.ext.plugin.model.PluginType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_PluginType.class));
      case "org.guvnor.structure.repositories.NewBranchEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_NewBranchEvent.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.image.definition.PictureFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_image_definition_PictureFieldDefinition.class));
      case "org.uberfire.java.nio.file.FileSystemException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_FileSystemException.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.SetChildNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SetChildNodeCommand.class));
      case "org.kie.workbench.common.stunner.core.diagram.DiagramParsingException": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_diagram_DiagramParsingException.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.MorphNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_MorphNodeCommand.class));
      case "org.uberfire.ext.security.management.api.Capability": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_Capability.class));
      case "org.guvnor.common.services.shared.test.Failure": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_test_Failure.class));
      case "org.ext.uberfire.social.activities.model.SocialPaged": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialPaged.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.Max": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_Max.class));
      case "org.uberfire.workbench.events.ResourceBatchChangesEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_ResourceBatchChangesEvent.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.UserTaskExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_UserTaskExecutionSet.class));
      case "org.uberfire.ext.properties.editor.model.validators.ColorValidator": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_validators_ColorValidator.class));
      case "org.uberfire.java.nio.file.AccessDeniedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_AccessDeniedException.class));
      case "org.kie.workbench.common.stunner.core.definition.property.type.ColorType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_property_type_ColorType.class));
      case "org.ext.uberfire.social.activities.model.SocialActivitiesEvent$LINK_TYPE": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_model_SocialActivitiesEvent_erraiD_LINK_erraiU_TYPE.class));
      case "org.uberfire.ext.editor.commons.file.exports.PdfExportPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_PdfExportPreferences.class));
      case "org.kie.workbench.common.stunner.core.rule.impl.CanConnect": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_CanConnect.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.TaskName": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_TaskName.class));
      case "org.drools.workbench.models.datamodel.rule.BaseSingleFieldConstraint": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_BaseSingleFieldConstraint.class));
      case "org.kie.workbench.common.forms.model.impl.meta.ModelMetaDataImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_ModelMetaDataImpl.class));
      case "org.uberfire.workbench.model.impl.PerspectiveDefinitionImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_model_impl_PerspectiveDefinitionImpl.class));
      case "org.guvnor.common.services.project.service.GAVAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_service_GAVAlreadyExistsException.class));
      case "org.uberfire.ext.security.management.api.exception.GroupNotFoundException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_GroupNotFoundException.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.relations.TableColumnMeta": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_relations_TableColumnMeta.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.font.FontSize": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_font_FontSize.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.AddConnectorCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_AddConnectorCommand.class));
      case "org.kie.workbench.common.stunner.core.definition.impl.PropertyImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_definition_impl_PropertyImpl.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.SetParentNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_SetParentNodeCommand.class));
      case "org.kie.workbench.common.stunner.core.graph.store.GraphNodeStoreImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_store_GraphNodeStoreImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.error.CancellingErrorEventExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_error_CancellingErrorEventExecutionSet.class));
      case "org.uberfire.ext.plugin.event.MediaDeleted": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_event_MediaDeleted.class));
      case "org.drools.workbench.models.datamodel.rule.ActionExecuteWorkItem": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_ActionExecuteWorkItem.class));
      case "org.kie.workbench.common.stunner.bpmn.workitem.ServiceTaskExecutionSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_workitem_ServiceTaskExecutionSet.class));
      case "org.uberfire.preferences.shared.impl.exception.InvalidPreferenceScopeException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_exception_InvalidPreferenceScopeException.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.ScriptTask": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_ScriptTask.class));
      case "org.uberfire.ext.properties.editor.model.PropertyEditorCategory": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorCategory.class));
      case "org.uberfire.java.nio.file.AtomicMoveNotSupportedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_java_nio_file_AtomicMoveNotSupportedException.class));
      case "org.kie.workbench.common.stunner.core.rule.impl.CanContain": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_impl_CanContain.class));
      case "org.uberfire.backend.vfs.PathFactory$PathImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_PathFactory_erraiD_PathImpl.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.DockingRuleViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_DockingRuleViolation.class));
      case "org.ext.uberfire.social.activities.events.SocialUserFollowedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_ext_uberfire_social_activities_events_SocialUserFollowedEvent.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.DefaultSelectorOption": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_DefaultSelectorOption.class));
      case "org.kie.soup.project.datamodel.oracle.MethodInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_MethodInfo.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.EndTerminateEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndTerminateEvent.class));
      case "org.uberfire.ext.plugin.model.Activity": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Activity.class));
      case "org.uberfire.preferences.shared.bean.mock.PortablePreferenceMockPortableGeneratedImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_bean_mock_PortablePreferenceMockPortableGeneratedImpl.class));
      case "org.uberfire.ext.layout.editor.api.editor.LayoutRow": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_layout_editor_api_editor_LayoutRow.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.simulation.SimulationSet": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_simulation_SimulationSet.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.EndSignalEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_EndSignalEvent.class));
      case "org.uberfire.ext.services.shared.preferences.MultiGridPreferencesStore": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_MultiGridPreferencesStore.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.TimerSettingsFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_TimerSettingsFieldType.class));
      case "org.guvnor.common.services.shared.message.Level": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_shared_message_Level.class));
      case "org.guvnor.structure.repositories.RepositoryUpdatedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_RepositoryUpdatedEvent.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.slider.definition.DoubleSliderDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_slider_definition_DoubleSliderDefinition.class));
      case "org.uberfire.ext.security.management.api.exception.OperationFailedException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_OperationFailedException.class));
      case "org.kie.soup.project.datamodel.oracle.Annotation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_Annotation.class));
      case "org.uberfire.ext.security.management.impl.SearchRequestImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_impl_SearchRequestImpl.class));
      case "org.uberfire.backend.vfs.impl.ObservablePathImpl": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_vfs_impl_ObservablePathImpl.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.event.IsInterrupting": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_event_IsInterrupting.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableListParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableListParameterDefinition.class));
      case "org.uberfire.ext.plugin.model.Framework": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_plugin_model_Framework.class));
      case "org.kie.workbench.common.forms.fields.shared.model.meta.entries.FieldPlaceHolderEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_model_meta_entries_FieldPlaceHolderEntry.class));
      case "org.kie.workbench.common.stunner.core.command.impl.CompositeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_command_impl_CompositeCommand.class));
      case "org.uberfire.ext.security.management.api.exception.UnsupportedServiceCapabilityException": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_security_management_api_exception_UnsupportedServiceCapabilityException.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.EdgeCardinalityMaxRuleViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_EdgeCardinalityMaxRuleViolation.class));
      case "org.kie.workbench.common.stunner.core.graph.command.impl.RegisterNodeCommand": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_graph_command_impl_RegisterNodeCommand.class));
      case "org.guvnor.structure.repositories.PullRequestAlreadyExistsException": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_PullRequestAlreadyExistsException.class));
      case "org.kie.soup.project.datamodel.oracle.FieldAccessorsAndMutators": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_soup_project_datamodel_oracle_FieldAccessorsAndMutators.class));
      case "org.drools.workbench.models.datamodel.workitems.PortableEnumParameterDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_workitems_PortableEnumParameterDefinition.class));
      case "org.kie.workbench.common.stunner.core.rule.violations.CardinalityMaxRuleViolation": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_violations_CardinalityMaxRuleViolation.class));
      case "org.uberfire.preferences.shared.impl.PreferenceScopeResolutionStrategyInfo": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_impl_PreferenceScopeResolutionStrategyInfo.class));
      case "org.guvnor.structure.repositories.PullRequestStatus": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_repositories_PullRequestStatus.class));
      case "org.kie.workbench.common.forms.model.impl.meta.entries.FieldReadOnlyEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_model_impl_meta_entries_FieldReadOnlyEntry.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.VariablesEditorFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_VariablesEditorFieldDefinition.class));
      case "org.drools.workbench.models.datamodel.rule.CompositeFieldConstraint": return putMarshaller(a0, GWT.create(Marshaller_for_org_drools_workbench_models_datamodel_rule_CompositeFieldConstraint.class));
      case "org.guvnor.structure.config.SystemRepositoryChangedEvent": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_structure_config_SystemRepositoryChangedEvent.class));
      case "org.uberfire.security.impl.authz.DefaultAuthorizationEntry": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_security_impl_authz_DefaultAuthorizationEntry.class));
      case "org.uberfire.ext.services.shared.preferences.GridGlobalPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_GridGlobalPreferences.class));
      case "org.kie.workbench.common.stunner.forms.model.ColorPickerFieldType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_forms_model_ColorPickerFieldType.class));
      case "org.kie.workbench.common.stunner.bpmn.definition.property.task.MultipleInstanceDataInput": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_definition_property_task_MultipleInstanceDataInput.class));
      case "org.kie.workbench.common.forms.fields.shared.fieldTypes.basic.selectors.listBox.definition.DecimalListBoxFieldDefinition": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_forms_fields_shared_fieldTypes_basic_selectors_listBox_definition_DecimalListBoxFieldDefinition.class));
      case "org.kie.workbench.common.stunner.core.preferences.StunnerPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_preferences_StunnerPreferences.class));
      case "org.uberfire.ext.editor.commons.file.exports.FileExportsPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_editor_commons_file_exports_FileExportsPreferences.class));
      case "org.kie.workbench.common.stunner.core.preferences.StunnerDiagramEditorPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_preferences_StunnerDiagramEditorPreferences.class));
      case "org.guvnor.common.services.project.preferences.GeneralPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_preferences_GeneralPreferences.class));
      case "org.guvnor.common.services.project.preferences.GAVPreferences": return putMarshaller(a0, GWT.create(Marshaller_for_org_guvnor_common_services_project_preferences_GAVPreferences.class));
      case "org.uberfire.preferences.shared.bean.mock.PortablePreferenceMock": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_preferences_shared_bean_mock_PortablePreferenceMock.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.AssigneeType": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_AssigneeType.class));
      case "org.kie.workbench.common.stunner.core.validation.Violation$Type": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_validation_Violation_erraiD_Type.class));
      case "org.uberfire.ext.properties.editor.model.PropertyEditorType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_properties_editor_model_PropertyEditorType.class));
      case "org.kie.workbench.common.stunner.core.rule.context.EdgeCardinalityContext$Direction": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_rule_context_EdgeCardinalityContext_erraiD_Direction.class));
      case "org.kie.workbench.common.stunner.bpmn.forms.model.ScriptTypeMode": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_bpmn_forms_model_ScriptTypeMode.class));
      case "org.uberfire.ext.services.shared.preferences.UserPreferencesType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_ext_services_shared_preferences_UserPreferencesType.class));
      case "org.uberfire.backend.plugin.PluginProcessor$PluginProcessorType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_backend_plugin_PluginProcessor_erraiD_PluginProcessorType.class));
      case "org.kie.workbench.common.stunner.core.command.CommandResult$Type": return putMarshaller(a0, GWT.create(Marshaller_for_org_kie_workbench_common_stunner_core_command_CommandResult_erraiD_Type.class));
      case "org.uberfire.workbench.events.NotificationEvent$NotificationType": return putMarshaller(a0, GWT.create(Marshaller_for_org_uberfire_workbench_events_NotificationEvent_erraiD_NotificationType.class));
      default: return false;
    }
  }

  public Marshaller getMarshaller(String a0) {
    if (a0 == null) {
      return null;
    }
    Marshaller m = marshallers.get(a0);
    if (m != null) {
      return m;
    } else if (loadMarshaller0(a0)) {
      return marshallers.get(a0);
    } else if (loadMarshaller1(a0)) {
      return marshallers.get(a0);
    }
    return null;
  }

  public void registerMarshaller(String a0, Marshaller a1) {
    marshallers.put(a0, a1);
  }
}